#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char *fname = "P2-06randuv2d.c";
char *title = "2PʃxNg쐬vO";

// ̓j[
char *menu[] = {
	" 1/5. o͉摜̃t@C@",
	" 2/5. 摜̕@@@@@@@",
	" 3/5. 摜̍@@@@@@",
	" 4/5. l@@",
	" 5/5. PʃxNg̐@@@",
};

// O[oϐ̐錾Əlݒ
char   g_f1[50] = "n2-06randuv2.img"; // 1. o͉摜̃t@C
int    g_nx = 256;                    // 2. 摜̕
int    g_ny = 256;                    // 3. 摜̍
int    g_sr = 1;                      // 4D̏
int    g_nn = 100000;                 // 5D̕\

float  *g_img;                        // 摜̈

// vg^Cv錾
void randuv2d(float *img, int nx, int ny, int nn);
void write_data(char *fi, float *img, int size);
void seed_xor128(unsigned long s);
double dxor128();

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_sr);
	if (*fgets(dat, 256, stdin) != '\n')  g_sr = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// ̏
	seed_xor128(g_sr);

	// 摜̈̊m
	g_img = (float *)malloc((size_t)g_nx*g_ny * sizeof(float));

	// 摜̍쐬iɍWj
	randuv2d(g_img, g_nx, g_ny, g_nn);

	// 摜̏o
	write_data(g_f1, g_img, g_nx*g_ny);

	// 摜̈̊J
	free(g_img);

	return 0;
}

// *** 2PʃxNg̗摜̍쐬 ***
// float *img;  // 摜f[^
// int   nx;    // 摜̕
// int   ny;    // 摜̍
// int   nn;    // _̐
void randuv2d(float *img, int nx, int ny, int nn)
{
	int     i, ix, iy;
	double  r, t, x, y;

	// 摜̏
	for (i = 0; i < nx*ny; i++)
		img[i] = 0;

	// 2PʃxNg\摜̍쐬
	// a͑Ίp1/4ɌŒ
	r = sqrt((double)(nx*nx + ny*ny)) / 4;
	for (i = 0; i < nn; i++)
	{
		t = 2 * PI*dxor128(); // px(0`2)
		// Wnւ̕ϊ
		x = r * cos(t); // x = r cos()
		y = r * sin(t); // y = r sin()
		// 摜Wւ̕ϊi_ȉ͎ľܓj
		ix = (int)(x + nx / 2 + 0.5);
		iy = (int)(ny / 2 - y + 0.5);
		img[iy*nx + ix] += 1;
	}
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char *fi, float *img, int size)
{
	FILE   *fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}


// ***********************************************
// *** Xorshift^񐶐@iݒtj***
// ***********************************************

// p̔z
static unsigned long seed[4] = { 123456789, 362436069, 521288629, 88675123 };

// *** ̏ ***
// unsigned long  s;  // ilj
void seed_xor128(unsigned long s)
{
	for (unsigned long i = 0; i < 4; ++i) seed[i] = s = 1812433253U * (s ^ (s >> 30)) + i;
}

// *** [0,1]̈l ***
double dxor128(void)
{
	unsigned long *x = seed;
	unsigned long  t = (x[0] ^ (x[0] << 11));
	x[0] = x[1]; x[1] = x[2]; x[2] = x[3];
	x[3] = (x[3] ^ (x[3] >> 19)) ^ (t ^ (t >> 8));
	return x[3] / (double)(ULONG_MAX);
}
