#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// vO̐
char* fname = "P4-08sorenson.c";
char* title = "Sorenson@œef[^␳vO";

// ̓j[
char* menu[] = {
	" 1/7. ␳O̓ef[^̃t@C  ",
	" 2/7. ␳̓ef[^̃t@C  ",
	" 3/7. ef[^̃r    ",
	" 4/7. ef[^̓e    ",
	" 5/7. ~̔a  icmj      ",
	" 6/7. sNZicmj      ",
	" 7/7. Wi1/cmj    ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-07_2all.prj";  // 1. ␳O̓ef[^̃t@C
char    g_f2[50] = "n4-08_0all.prj";  // 2. ␳̓ef[^̃t@C
int     g_px = 128;                   // 3. ef[^̃r
int     g_pa = 128;                   // 4. ef[^̓e
double  g_cr = 10;                    // 5. ~̔aicmj
double  g_pl = 32.0/128;              // 6. sNZicmj
double  g_mu = 0.15;                  // 7DWi1/cmj

float* g_prj;  // ef[^̈

// vg^Cv錾
void sorenson(float* prj, int px, int pa, double r, double pl, double mu);
void read_data(char *, float *, int);
void write_data(char *, float *, int);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_cr);
	if (*fgets(dat, 256, stdin) != '\n')  g_cr = atof(dat);
	printf(" %s [%f] :", menu[i++], g_pl);
	if (*fgets(dat, 256, stdin) != '\n')  g_pl = atof(dat);
	printf(" %s [%f] :", menu[i++], g_mu);
	if (*fgets(dat, 256, stdin) != '\n')  g_mu = atof(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float *)malloc((size_t)g_px*g_pa*sizeof(float));

	// ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px * g_pa);

	// Sorenson@ɂO␳
	sorenson(g_prj, g_px, g_pa, g_cr, g_pl, g_mu);

	// ␳̓ef[^̕ۑ
	write_data(g_f2, g_prj, g_px * g_pa);

	// 摜̈̊J
	free(g_prj);

	return 0;
}

// Sorenson̑O␳@œef[^␳֐
// float    *prj;   // ef[^
// int      px;     // ef[^̃r
// int      pa;     // ef[^̓e
// double   r;      // ~̔a  icmj
// double   pl;     // sNZicmj
// double   mu;     // Wi1/cmj
void sorenson(float *prj, int px, int pa, double r, double pl, double mu) 
{
	int    i, j;
	float* T;

	T = (float*)malloc((size_t)px * pa * sizeof(float));

	// ~̒[܂ł̒
	for (i = 0; i < px; i++) {
		double x = (i - px / 2) * pl;
		double d = r * r - x * x;
		if (d > 0) T[i] = (float)sqrt(d);
		else       T[i] = 0;
	}
	for (i = 1; i < pa; i++) {
		for (j = 0; j < px; j++) {
			T[i * px + j] = T[j];
		}
	}
	write_data("n4-08_2T.prj", T, px * pa);

	// ΌʒuƂ̊􉽕
	for (i = 0; i < px * pa; i++)
		if (prj[i] < 0) prj[i] = 0;
	for (i = 0; i < pa / 2; i++) {
		for (j = 1; j < px; j++) {
			prj[i * px + j] = (float)(sqrt(prj[i * px + j] * prj[(i + pa / 2) * px + px - j]));
			prj[(i + pa / 2) * px + px - j] = prj[i * px + j];
		}
	}
	write_data("n4-08_3G.prj", prj, px * pa);

	// ␳ľvZ
	for (i = 0; i < px * pa; i++) {
		if (T[i] == 0)  continue;
		else    T[i] = (float)(mu * T[i] / (1 - exp(-mu * T[i])));
	}
	write_data("n4-08_4mT.prj", T, px * pa);

	// e̕␳
	for (i = 0; i < px * pa; i++) {
		prj[i] *= T[i];
	}

	free(T);
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
