#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// vO̐
char *fname = "P4-16psf_mean.c";
char *title = "PSF̕ςvZvO";

// ̓j[
char *menu[] = {
	" 1/4. PSF摜̃t@C ",
	" 2/4. PSF̃t@C ",
	" 3/4. 摜̕            ",
	" 4/4. 摜̍          ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-15_0img.img";  // 1DPSF摜̃t@C
char    g_f2[50] = "n4-16_psf.csv";   // 2DPSF̃t@C
int     g_nx = 128;                   // 3D摜̕
int     g_ny = 128;                   // 4D摜̍

float*  g_img;  // 摜f[^̈
float*  g_psf;  // PSFf[^̈

// vg^Cv錾
void psf_mean(float*psf, float *img, int nx, int ny);
void read_data(char* fi, float* img, int size);
void write_data_csv(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);

	printf("\n");
}

int main(void)
{
	int i;

	getparameter();

	// 摜̈̊mۂƏ
	g_img = (float*)malloc((size_t)g_nx * g_ny * sizeof(float));
	g_psf = (float*)malloc((size_t)g_nx * sizeof(float));
	for (i = 0; i < g_nx; i++)
		g_psf[i] = 0;

	// ef[^̓ǂݏo
	read_data(g_f1, g_img, g_nx * g_ny);

	// PSF̎Zo
	psf_mean(g_psf, g_img, g_nx, g_ny);

	// PSFf[^̕ۑ
	write_data_csv(g_f2, g_psf, g_nx);

	// 摜̈̊J
	free(g_img);
	free(g_psf);

	return 0;
}

// *** PSF̎Zo ***
// float  *psf;  // PSFf[^
// float  *img;  // PSF摜
// int     nx;   // 摜̕
// int     ny;   // 摜̍
void psf_mean(float* psf, float* img, int nx, int ny)
{
	int    i, j;
	int*   cnt;  // JEgp̈
	float  sum = 0;

	// ̈̊mۂƏ
	cnt = (int*)malloc((size_t)g_nx * sizeof(int));
	for (i = 0; i < nx; i++)
		cnt[i] = 0;

	for (i = 0; i < ny; i++) {
		double y = ny / 2 - i;
		for (j = 0; j < nx; j++) {
			double x = j - nx / 2;
			double r = sqrt(x * x + y * y);
			int ir = (int)(r + 0.5);
			if (ir > nx / 2 - 1) continue;
			psf[ir + nx / 2] += img[i * nx + j];
			cnt[ir + nx / 2]++;
			psf[nx / 2 - ir] += img[i * nx + j];
			cnt[nx / 2 - ir]++;
		}
	}

	// PSF̎Zo
	for (i = 0; i < nx; i++)
		if(cnt[i] != 0)
			psf[i] /= cnt[i];

	// v1ɂȂ悤ɋKi
	for (i = 0; i < nx; i++)
		sum += psf[i];
	for (i = 0; i < nx; i++)
		psf[i] /= sum;

	free(cnt);
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** CSVf[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data_csv(char* fi, float* img, int size)
{
	int   i;
	FILE* fp;

	if ((fp = fopen(fi, "w")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	for (i = 0; i < size; i++)
		fprintf(fp, "%f\n", img[i]);
	fclose(fp);
}
