#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <direct.h>

#define PI 3.14159265358979

// vO̐
char* fname = "P4-24mlem_correct.c";
char* title = "␳tML-EM@̃vO";

// ̓j[
char* menu[] = {
	" 1/12. ef[^̃t@C ",
	" 2/12. ef[^̃r     ",
	" 3/12. ef[^̓e     ",
	" 4/12. č\摜̃t@C ",
	" 5/12. č\摜̕         ",
	" 6/12. č\摜̍       ",
	" 7/12. JԂ           ",
	" 8/12. ]S܂ł̋(cm) ",
	" 9/12. ȉ~̒a(cm)       ",
	"10/12. ȉ~̒Za(cm)       ",
	"11/12. sNZ(cm/pixel)   ",
	"12/12. W(1/cm)       ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-07_2all.prj";  // 1Def[^̃t@C
int     g_px = 128;                   // 2Def[^̃r
int     g_pa = 128;                   // 3. ef[^̓e
char    g_f2[50] = "n4-24_0all.img";  // 4Dč\摜̃t@C
int     g_nx = 128;                   // 5Dč\摜̕
int     g_ny = 128;                   // 6. č\摜̍
int     g_nn = 50;                    // 7. JԂ
double  g_d0 = 20.0;                  // 8. ỏ]S܂ł̋icmj
double  g_a = 10;                     // 9. ȉ~̒aicmj
double  g_b = 10;                     // 10.ȉ~̒Zaicmj
double  g_pl = 32.0 / 128.0;          // 11.sNZicm/pixelj
double  g_mu = 0.154359;              // 12.Wi1/cmj

float* g_prj;                         // ef[^̈
float* g_img;                         // č\摜̈

// vg^Cv錾
void mlem_correct(float* img, int nx, int ny, float* prj, int px, int pa, int n);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atol(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_d0);
	if (*fgets(dat, 256, stdin) != '\n')  g_d0 = atof(dat);
	printf(" %s [%f] :", menu[i++], g_a);
	if (*fgets(dat, 256, stdin) != '\n')  g_a = atof(dat);
	printf(" %s [%f] :", menu[i++], g_b);
	if (*fgets(dat, 256, stdin) != '\n')  g_b = atof(dat);
	printf(" %s [%f] :", menu[i++], g_pl);
	if (*fgets(dat, 256, stdin) != '\n')  g_pl = atof(dat);
	printf(" %s [%f] :", menu[i++], g_mu);
	if (*fgets(dat, 256, stdin) != '\n')  g_mu = atof(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float*)malloc((size_t)g_px * g_pa * sizeof(float));
	g_img = (float*)malloc((size_t)g_nx * g_ny * sizeof(float));

	// ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px * g_pa);

	// ML-EM@
	mlem_correct(g_img, g_nx, g_ny, g_prj, g_px, g_pa, g_nn);

	// ef[^̕ۑ
	write_data(g_f2, g_img, g_nx * g_ny);

	// 摜̈̊J
	free(g_prj);
	free(g_img);

	return 0;
}

// *** omCij̍쐬iCUCoj ***
// float  *cij;  // ef[^
// int     px;   // e̕
// int     pa;   // e
// int     nx;   // 摜̕
// int     ny;   // 摜̍
// double  ra;   // ȉ~̒aicmj
// double  rb;   // ȉ~̒Zaicmj
// double  pl;   // sNZicm/pixelj
// double  mu;   // Wi1/cmj
void make_cij_ellipse(float* cij, int px, int pa, int nx, int ny, double ra, double rb, double pl, double mu)
{
	int     i, j, k, m, ix, mx;
	double  th, si, co, sia, coa, a, b, h, x, y, x0, xr, yr;
	double  a0, a1, a2, d0, L, A, B, C;
	float*  psf;

	// PSF̌W
	double  psfa = 0.013423;
	double  psfb = 0.067791;
	double  psfc = 0.106577;
	double  psfd = 0.099052;
	double  sb, sd;
	float   buf;

	psf = (float*)malloc((size_t)px / 2 * sizeof(float));

	// 
	for (i = 0; i < px * pa * nx * ny; i++)
		cij[i] = 0;
	d0 = g_d0 / pl;  // ]S܂ł̋pixelPʂɕϊ
	ra /= pl;        // ȉ~̒apixelPʂɕϊ
	rb /= pl;        // ȉ~̒ZapixelPʂɕϊ
	mu *= pl;        // W1/pixelPʂɕϊ

	for (i = 0; i < pa; i++) {
		th = 2 * PI * i / pa;
		si = sin(th);
		co = cos(th);
		sia = fabs(si);
		coa = fabs(co);
		a = fabs(coa - sia) / 2;
		b = (coa + sia) / 2;
		h = coa > sia ? 1 / coa : 1 / sia;
		for (j = 0; j < ny; j++) {
			y = ny / 2 - j;
			for (k = 0; k < nx; k++) {
				x = k - nx / 2;
				if (x * x / (ra * ra) + y * y / (rb * rb) > 1) continue; // ȉ~͈̔͊O
				x0 = x * co + y * si + px / 2;
				ix = (int)floor(x0 + 0.5);
				if (ix < 1 || ix > px - 2) continue;
				L = ix + 0.5 - x0;
				if (L <= a)     a2 = (a - L) * h + (b - a) * h / 2;
				else if (L < b) a2 = (b - L) * (b - L) * h / (2 * (b - a));
				else            a2 = 0;
				L = 1 - L;
				if (L <= a)     a0 = (a - L) * h + (b - a) * h / 2;
				else if (L < b) a0 = (b - L) * (b - L) * h / (2 * (b - a));
				else            a0 = 0;
				a1 = 1 - a0 - a2;
				// ̍liȉ~j
				xr = x * co + y * si;
				yr = -x * si + y * co;
				A = ra * ra * co * co + rb * rb * si * si;
				B = (ra * ra - rb * rb) * xr * co * si;
				C = (ra * ra * si * si + rb * rb * co * co) * xr * xr - ra * ra * rb * rb;
				//if (B * B - A * C <= 0.0) continue;
				L = yr + (B + sqrt(B * B - A * C)) / A;
				a0 *= exp(-mu * L);
				a1 *= exp(-mu * L);
				a2 *= exp(-mu * L);
				// ɈˑPSF̍쐬iUlj
				L = d0 / (yr + d0);
				sb = psfb * L;
				sd = psfd * L * L;
				buf = 0;
				for (m = 0; m < px / 2; m++) {
					x = fabs(m - px / 4);
					psf[m] = (float)(psfa * exp(-sb * x) + psfc * exp(-sd * x * x));
					buf += psf[m];
				}
				for (m = 0; m < px / 2; m++) {
					psf[m] /= buf;  // v1ɂȂ悤ɋKi
				}
				// PSF̍l
				for (m = 0; m < px / 2; m++) {
					mx = m - px / 4;
					if (ix - 1 + mx >= 0 && ix - 1 + mx < px)
						cij[i * px * nx * ny + (ix - 1 + mx) * nx * ny + j * nx + k] += (float)(a0 * psf[m]);
					if (ix + mx >= 0 && ix + mx < px)
						cij[i * px * nx * ny + (ix + mx) * nx * ny + j * nx + k] += (float)(a1 * psf[m]);
					if (ix + 1 + mx >= 0 && ix + 1 + mx < px)
						cij[i * px * nx * ny + (ix + 1 + mx) * nx * ny + j * nx + k] += (float)(a2 * psf[m]);
				}
			}
		}
	}
}

// *** 1̓es֐ ***
// float*  prj;  // ef[^
// int     px;   // ef[^̕
// float*  img;  // 摜f[^
// int     nn;   // 摜f[^̃sNZ
// float*  cij;  // om
void forward_projection(float *prj, int px, float *img, int nn, float *cij) 
{
	int    i, j;

	for(i = 0 ; i < px ; i++) {
		for(j = 0 ; j < nn ; j++) {
			prj[i] += cij[i * nn + j] * img[j];
		}
	}
}

// *** 1ւ̋te߂֐ ***
// float*  img;  // 摜f[^
// int     nn;   // 摜f[^̃sNZ
// float*  prj;  // ef[^
// int     px;   // ef[^̕
// float*  cij;  // om
void back_projection(float* img, int nn, float* prj, int px, float* cij)
{
	int    i, j;

	for (i = 0; i < px; i++) {
		for (j = 0; j < nn; j++) {
			img[j] += cij[i * nn + j] * prj[i];
		}
	}
}

// *** ␳tML_EM@s֐ ***
// float   *img;  쐬摜f[^
// int     nx;    摜f[^̕ixj
// int     ny;    摜f[^̍iyj
// float   *prj;  ̓ef[^
// int     px;    ef[^̓a̐
// int     pa;    ef[^̊px̐
// int     n;     JԂ
void mlem_correct(float* img, int nx, int ny, float* prj, int px, int pa, int n)
{
	int     i, j;
	char    fi[50];
	float*  cij, *c0, * aprj, * rprj, * aimg;

	cij = (float*)malloc((size_t)px * pa * nx * ny * sizeof(float));
	c0 = (float*)malloc((size_t)nx * ny * sizeof(float));
	aprj = (float*)malloc((size_t)px * pa * sizeof(float));
	rprj = (float*)malloc((size_t)px * pa * sizeof(float));
	aimg = (float*)malloc((size_t)nx * ny * sizeof(float));

	// ۑptH_̍쐬
	_mkdir("n4-24");

	// omcij̍쐬
	make_cij_ellipse(cij, nx, ny, px, pa, g_a, g_b, g_pl, g_mu);

	// ef[^̒[̃G[ɘaiE5sNZj
	for (i = 0; i < pa; i++) {
		for (j = 0; j < 6; j++) {
			prj[i * px + j] *= (float)((cos(PI * (5 - j) / 5) + 1) / 2);
			prj[i * px + px - j - 1] *= (float)((cos(PI * (5 - j) / 5) + 1) / 2);
		}
	}

	// ml-em itaration
	// omcij̋KiW̍쐬
	for (i = 0; i < nx * ny; i++) {
		c0[i] = 0;
		for (j = 0; j < pa * px; j++)
			c0[i] += cij[j * nx * ny + i];
		if (c0[i] == 0) c0[i] = 1;
	}

	// @ 摜肷
	for (i = 0; i < nx * ny; i++)
		img[i] = 1;

	for (i = 0; i < n; i++) {
		fprintf(stderr, "\r *** ML-EM iteration [%2d/%2d]", i + 1, n);
		for (j = 0; j < px * pa; j++) aprj[j] = rprj[j] = 0;
		for (j = 0; j < nx * ny; j++) aimg[j] = 0;
		// A 摜瓊evZ
		for (j = 0; j < pa; j++)
			forward_projection(aprj + j * px, px, img, nx * ny, cij + j * px * nx * ny);
		// B e̔vZ
		for (j = 0; j < px * pa; j++)
			if (aprj[j] > 1)  rprj[j] = prj[j] / aprj[j];
		// C te
		for (j = 0; j < pa; j++)
			back_projection(aimg, nx * ny, rprj + j * px, px, cij + j * px * nx * ny);
		// D Kiĉ摜XV
		for (j = 0; j < nx * ny; j++)
			img[j] *= aimg[j] / c0[j];
		// r摜̕ۑ
		sprintf(fi, "n4-24/n4-24_0img%03d.img", i + 1);
		write_data(fi, img, nx * ny);
		sprintf(fi, "n4-24/n4-24_1aprj%03d.prj", i + 1);
		write_data(fi, aprj, px * pa);
		sprintf(fi, "n4-24/n4-24_2rprj%03d.prj", i + 1);
		write_data(fi, rprj, px * pa);
		sprintf(fi, "n4-24/n4-24_3aimg%03d.img", i + 1);
		write_data(fi, aimg, nx * ny);
	}
	printf("\n");
	free(cij);
	free(c0);
	free(aprj);
	free(rprj);
	free(aimg);
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
