#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <direct.h>

#define PI 3.14159265358979

// vO̐
char* fname = "P5-09dose_projection3d.c";
char* title = "3摜瓊ef[^쐬vO";

// ̓j[
char* menu[] = {
	" 1/8. 摜̃t@C ",
	" 2/8. 摜̕         ",
	" 3/8. 摜̍       ",
	" 4/8. 摜̉s       ",
	" 5/8. ef[^̃t@C ",
	" 6/8. ef[^̃rixj",
	" 7/8. ef[^̃rizj",
	" 8/8. ef[^̓e     ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n5-08.imv";  // 1Def[^̃t@C
int     g_nx = 256;              // 2Dč\摜̕
int     g_ny = 256;              // 3. č\摜̍
int     g_nz = 256;              // 4. č\摜̉s
char    g_f2[50] = "n5-09.imv";  // 5Dč\摜̃t@C
int     g_px = 256;              // 6Def[^̃r (x)
int     g_pz = 256;              // 7Def[^̃r (z)
int     g_pa = 256;              // 8. ef[^̓e

float* g_img;                    // 摜̈
float* g_prj;                    // ef[^̈

// vg^Cv錾
void projection3d(float* prj, int px, int pz, int pa, float* img, int nx, int ny, int nz);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atol(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nz);
	if (*fgets(dat, 256, stdin) != '\n')  g_nz = atoi(dat);
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pz);
	if (*fgets(dat, 256, stdin) != '\n')  g_pz = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊mۂƏ
	g_img = (float*)malloc((size_t)g_nx * g_ny * g_nz * sizeof(float));
	g_prj = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));

	// 摜̓ǂݏo
	read_data(g_f1, g_img, g_nx * g_ny * g_nz);

	// ML-EM@
	projection3d(g_prj, g_px, g_pz, g_pa, g_img, g_nx, g_ny, g_nz);

	// ef[^̕ۑ
	write_data(g_f2, g_prj, g_nx * g_nz * g_pa);

	// 摜̈̊J
	free(g_img);
	free(g_prj);

	return 0;
}

// *** 3摜瓊ef[^쐬֐ ***
// float*  prj;  // ef[^
// int     px;   // e̕   (x)
// int     pz;   // e̍ (z)
// int     pa;   // e
// float*  img;  // 摜̈
// int     nx;   // 摜̕
// int     ny;   // 摜̍
// int     nz;   // 摜̉s
void projection3d(float* prj, int px, int pz, int pa, float* img, int nx, int ny, int nz)
{
	int     i, j, k, ix, iz;
	double  th, si, co, sia, coa, a, b, h, x, y, x0;
	double  a0, a1, a2, L;

	for (i = 0; i < pa; i++) {
		fprintf(stderr, "\rProjection [%d/%d]", i + 1, pa);
		th = 2 * PI * i / pa;
		si = sin(th);
		co = cos(th);
		sia = fabs(si);
		coa = fabs(co);
		a = fabs(coa - sia) / 2;
		b = (coa + sia) / 2;
		h = coa > sia ? 1 / coa : 1 / sia;
		for (j = 0; j < ny; j++) {
			y = ny / 2 - j;
			for (k = 0; k < nx; k++) {
				x = k - nx / 2;
				x0 = x * co + y * si + px / 2;
				ix = (int)floor(x0 + 0.5);
				if (ix < 1 || ix > px - 2) continue;
				L = ix + 0.5 - x0; // Ěo
				if (L <= a)     a2 = (a - L) * h + (b - a) * h / 2; // case 1
				else if (L < b) a2 = (b - L) * (b - L) * h / (2 * (b - a)); // case 2
				else            a2 = 0; // case 3
				L = 1 - L; // ̌o
				if (L <= a)     a0 = (a - L) * h + (b - a) * h / 2; // case 1
				else if (L < b) a0 = (b - L) * (b - L) * h / (2 * (b - a)); // case 2
				else            a0 = 0; // case 3
				a1 = 1 - a0 - a2; // ̌o
				for (iz = 0; iz < nz; iz++) { // pz=nzƂ
					prj[i * px * pz + iz * px + ix - 1] += img[iz * nx * ny + j * nx + k] * (float)a0;
					prj[i * px * pz + iz * px + ix    ] += img[iz * nx * ny + j * nx + k] * (float)a1;
					prj[i * px * pz + iz * px + ix + 1] += img[iz * nx * ny + j * nx + k] * (float)a2;
				}
			}
		}
	}
	fprintf(stderr, "\n");
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
