#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define PI 3.14159265358979

// vO̐
char *fname = "P5-10dose_filter.c";
char *title = "č\tB^vO";

// ̓j[
char *menu[] = {
	" 1/5. ef[^̓̓t@C ",
	" 2/5. ef[^̏o̓t@C ",
	" 3/5. ef[^̃r (x)     ",
	" 4/5. ef[^̃r (z)     ",
	" 5/5. ef[^̓e         ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n5-09.imv";  // 1Def[^̓̓t@C
char    g_f2[50] = "n5-10.imv";  // 2Def[^̏o̓t@C
int     g_px = 256;              // 3Def[^̃r (x)
int     g_pz = 256;              // 4Def[^̃r (z)
int     g_pa = 256;              // 5. ef[^̓e

float*  g_prj;                   // ef[^̈

// vg^Cv錾
void dose_filter(float*prj, int px, int pz, int pa);
void filter(float* prj, int px, int pa);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);
void fft1d(int ir, float* imr, float* imi, int nx, int ny);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pz);
	if (*fgets(dat, 256, stdin) != '\n')  g_pz = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊m
	g_prj = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));

	// ef[^̓ǂݏo
	read_data(g_f1, g_prj, g_px *g_pz * g_pa);

	// tB^␳
	dose_filter(g_prj, g_px, g_pz, g_pa);

	// ef[^̕ۑ
	write_data(g_f2, g_prj, g_px * g_pz * g_pa);

	// 摜̈̊J
	free(g_prj);

	return 0;
}

// *** tB^␳ ***
// float  *prj;  // ef[^
// int     px;   // ef[^̃r (x)
// int     pz;   // ef[^̃r (z)
// int     pa;   // ef[^̓e
void dose_filter(float* prj, int px, int pz, int pa)
{
	int  i;
	float  mx;
	float* pri;  // ef[^̋

	// 摜̈̊mۂƏ
	pri = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));
	for (i = 0; i < g_px * g_pz * g_pa; i++)
		pri[i] = 0;

	for (i = 0; i < pa; i++) { // px͌JԂ
		float* pre = prj + i * px * pz;
		float* pim = pri + i * px * pz;

		// 1t[Gϊ 
		fft1d(1, pre, pim, px, pz);

		// tB^O
		filter(pre, px, pz);
		filter(pim, px, pz);

		// 1t[Gtϊ
		fft1d(-1, pre, pim, px, pz);
	}

	// l0ɂ
	for (i = 0; i < px * pz * pa; i++)
		if (prj[i] < 0) prj[i] = 0;

	// őlŋKii0`1̒lɂj
	mx = prj[0];
	for (i = 1; i < px * pz * pa; i++)
		if (prj[i] > mx) mx = prj[i];
	for (i = 0; i < px * pz * pa; i++)
		prj[i] /= mx;

	free(pri);
}

// *** tB^OiRamp+n~Oj ***
// float *prj;  // gԓef[^
// int    px;   // ef[^̃r (x)
// int    pz;   // ef[^̃r (z)
void filter(float* prj, int px, int pz)
{
	int     i, j;
	double  h0 = 0.25;

	// tB^̌_h0̌vZ
	for (i = 1; i < px / 2; i += 2)
		h0 -= 2.0 / (PI * PI * i * i);

	for (i = 0; i < pz; i++) {
		// tB^OiRamptB^j
		for (j = 0; j < px; j++) {
			double x = j - px / 2;
			double h = fabs(PI * x / px);  // ||̃tB^
			if (h == 0.0)  h = PI * h0;    // _̒l
			prj[i * px + j] *= (float)h;
		}
		// EBhEin~Oj
		for (j = 0; j < px; j++) {
			double x = j - px / 2;
			double h = 0.46 * cos(x * 2 * PI / px) + 0.54;
			prj[i * px + j] *= (float)h;
		}
	}
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** FFTɕKvȃf[^̍쐬iC]Cւpj***
// int     nx;        // 1FFT̃f[^
// double  *si;       // TCf[^   si[nx/2]
// double  *co;       // RTCf[^ co[nx/2]
// unsigned int *br;  // pf[^   brv[nx]
void FFTInit(int nx, double* si, double* co, unsigned int* br)
{
	int     i;
	double  dd = 2.0 * PI / nx;
	unsigned int  ur, ui, uc;

	// C]f[^̍쐬
	for (i = 0; i < nx / 2; i++) {
		si[i] = sin(dd * i);
		co[i] = cos(dd * i);
	}

	// ԓւpf[^̍쐬
	for (ui = 0; ui < (unsigned)nx; ui++) {
		ur = 0;
		for (uc = 1; uc <= (unsigned)nx / 2; uc <<= 1) {
			ur <<= 1;
			if ((ui & uc) != 0)
				ur++;
		}
		br[ui] = ur;
	}
}

/* 1t[GϊiFFTj */
// int     ir;        // ϊ(1)Ctϊ(-1)
// int     nx;        // 1FFT̃f[^
// double  *xr;       // ̃f[^   xr[nx]
// double  *xi;       // ̃f[^   xi[nx]
// double  *si;       // TCf[^   si[nx/2]
// double  *co;       // RTCf[^ co[nx/2]
// unsigned int *br;  // pf[^   br[nx]
void FFT(int ir, int nx, double* xr, double* xi, double* si, double* co, unsigned int* br)
{
	int     i, j, k, m, n1, n2 = nx, j3, j4, d = 1, g;
	double  a, b, c, s, tmp;

	// FFT̎sio^tCZj
	for (i = 1; i <= nx / 2; i *= 2, d += d) {
		g = 0;
		m = n2;
		n2 /= 2;
		for (k = 1; k <= n2; k++) {
			n1 = k - m;
			c = co[g];
			s = ir * si[g];
			g += d;
			for (j = m; j <= nx; j += m) {
				j3 = j + n1 - 1;
				j4 = j3 + n2;
				a = xr[j3] - xr[j4];
				b = xi[j3] - xi[j4];
				xr[j3] += xr[j4];
				xi[j3] += xi[j4];
				xr[j4] = c * a + s * b;
				xi[j4] = c * b - s * a;
			}
		}
	}

	// Ԃ̓ւ
	for (i = 0; i < nx; i++) {
		j = br[i];
		if (i < j) {
			tmp = xr[i];
			xr[i] = xr[j];
			xr[j] = tmp;
			tmp = xi[i];
			xi[i] = xi[j];
			xi[j] = tmp;
		}
	}

	// tϊ̏
	if (ir == -1) {
		for (i = 0; i < nx; i++) {
			xr[i] /= nx;
			xi[i] /= nx;
		}
	}
}

/* 2摜1t[GϊiFFT𗘗pj */
// int     ir;        // ϊ(1)Ctϊ(-1)
// float  *imr;       // ̃f[^   imr[nx*ny]
// float  *imi;       // ̃f[^   imi[nx*ny]
// int     nx;        // 摜f[^̕
// int     ny;        // 摜f[^̍
void fft1d(int ir, float* imr, float* imi, int nx, int ny)
{
	int     i, j;

	// FFTɗpf[^z̐錾
	double* xr, * xi, * si, * co;
	unsigned int* br;

	// x̔z̊m
	xr = (double*)malloc((size_t)nx * sizeof(double));
	xi = (double*)malloc((size_t)nx * sizeof(double));
	si = (double*)malloc((size_t)nx / 2 * sizeof(double));
	co = (double*)malloc((size_t)nx / 2 * sizeof(double));
	br = (unsigned int*)malloc((size_t)nx * sizeof(unsigned int));

	// FFTɕKvȃf[^̍쐬
	FFTInit(nx, si, co, br);

	// x̃t[Gϊ
	for (i = 0; i < ny; i++) {
		// f[^̓ւi_擪Ɉړj
		for (j = 0; j < nx / 2; j++) {
			xr[j] = imr[i * nx + j + nx / 2];
			xr[j + nx / 2] = imr[i * nx + j];
			xi[j] = imi[i * nx + j + nx / 2];
			xi[j + nx / 2] = imi[i * nx + j];
		}

		// FFT̎s
		FFT(ir, nx, xr, xi, si, co, br);

		// f[^̓ւi_𒆉ɖ߂j
		for (j = 0; j < nx / 2; j++) {
			imr[i * nx + j + nx / 2] = (float)xr[j];
			imr[i * nx + j] = (float)xr[j + nx / 2];
			imi[i * nx + j + nx / 2] = (float)xi[j];
			imi[i * nx + j] = (float)xi[j + nx / 2];
		}
	}
}
