#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char *fname = "P2-10randuv3d_iso.c";
char *title = "3PʃxNg𓙕Iɍ쐬vO";

// ̓j[
char *menu[] = {
	" 1/6. o͉摜̃t@C@",
	" 2/6. 摜̕@@@@@@@",
	" 3/6. 摜̍@@@@@@",
	" 4/6. 摜̉s@@@@@@",
	" 5/6. l@@",
	" 6/6. W_̐@@@@",
};

// O[oϐ̐錾Əlݒ
char   g_f1[50] = "n2-10randuv3_iso.imv"; // 1. o͉摜̃t@CiIj
int    g_nx = 256;                        // 2. 摜̕@ixj
int    g_ny = 256;                        // 3. 摜̍iyj
int    g_nz = 256;                        // 4. 摜̉sizj
int    g_sr = 1;                          // 5D̏
int    g_nn = 1000000;                    // 6D̕\

float  *g_img;                            // 摜̈

// vg^Cv錾
void randuv3d_iso(float *img, int nx, int ny, int nz, int nn);
void write_data(char *fi, float *img, int size);
void seed_xor128(unsigned long s);
double dxor128();

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nz);
	if (*fgets(dat, 256, stdin) != '\n')  g_nz = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_sr);
	if (*fgets(dat, 256, stdin) != '\n')  g_sr = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// ̏
	seed_xor128(g_sr);

	// 摜̈̊m
	g_img = (float *)malloc((size_t)g_nx*g_ny*g_nz * sizeof(float));

	// 摜̍쐬iIj
	randuv3d_iso(g_img, g_nx, g_ny, g_nz, g_nn);

	// 摜̏o
	write_data(g_f1, g_img, g_nx*g_ny*g_nz);

	// 摜̈̊J
	free(g_img);

	return 0;
}

// *** 3PʃxNg̗摜̍쐬iIj ***
// float *img;  // 摜f[^
// int   nx;    // 摜̕
// int   ny;    // 摜̍
// int   nz;    // 摜̉s
// int   nn;    // _̐
void randuv3d_iso(float *img, int nx, int ny, int nz, int nn)
{
	int     i, ix, iy, iz;
	double  x, y, z, w, r;

	// 摜̏
	for (i = 0; i < nx*ny*nz; i++)
		img[i] = 0;

	// ̊p\摜̍쐬
	// axyʂ̑Ίp1/4ɌŒ
	r = sqrt((double)(nx*nx + ny*ny)) / 4;
	for (i = 0; i < nn; i++)
	{
		// W}1̗̓̔CӍW̐
		x = 2 * dxor128() - 1;
		y = 2 * dxor128() - 1;
		z = 2 * dxor128() - 1;

		// Pʉ~Ɍ肷iIɂ邽߁j
		w = sqrt(x * x + y * y + z * z);
		if (w != 0.0 && w <= 1.0) // w=0̏ꍇȂ
		{
			// PʃxNgɕϊ
			x /= w;
			y /= w;
			z /= w;

			// ar̋ɔzu(摜Wɕϊ)
			ix = (int)(r*x + nx / 2 + 0.5);
			iy = (int)(ny / 2 - r*y + 0.5);
			iz = (int)(nz / 2 - r*z + 0.5);

			img[iz*nx*ny + iy * nx + ix] ++;
		}
		else
		{
			i--;
		}
	}
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char *fi, float *img, int size)
{
	FILE   *fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}


// ***********************************************
// *** Xorshift^񐶐@iݒtj***
// ***********************************************

// p̔z
static unsigned long seed[4] = { 123456789, 362436069, 521288629, 88675123 };

// *** ̏ ***
// unsigned long  s;  // ilj
void seed_xor128(unsigned long s)
{
	for (unsigned long i = 0; i < 4; ++i) seed[i] = s = 1812433253U * (s ^ (s >> 30)) + i;
}

// *** [0,1]̈l ***
double dxor128(void)
{
	unsigned long *x = seed;
	unsigned long  t = (x[0] ^ (x[0] << 11));
	x[0] = x[1]; x[1] = x[2]; x[2] = x[3];
	x[3] = (x[3] ^ (x[3] >> 19)) ^ (t ^ (t >> 8));
	return x[3] / (double)(ULONG_MAX);
}
