#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// vO̐
char *fname = "P3-02interaction.c";
char *title = "ɂ鑊ݍp̃vO";

// ̓j[
char *menu[] = {
	" 1/4. ˌq̃GlM[ (keV) ",
	" 2/4. ʑ̂̒ t       (cm)  ",
	" 3/4. oq n@@@     ",
	" 4/4. l         ",
};

// O[oϐ̐錾Əlݒ
double  g_eg = 100.0;         // 1Dˌq̃GlM[ (keV)
double  g_t  = 10.0;          // 2. ʑ̂̒ t       (cm)
int     g_nn = 1000000;       // 3Doq n
unsigned long g_sr = 1;       // 4. l

// (H20)̒萔
// GlM[(MeV)ƒfʐ(cm^2/g)idʁCUC񊱏Uj
double g_WtEn[25] = { 1.00E-03,1.50E-03,2.00E-03,3.00E-03,4.00E-03,5.00E-03,6.00E-03,8.00E-03,1.00E-02,1.50E-02,2.00E-02,3.00E-02,4.00E-02,5.00E-02,6.00E-02,8.00E-02,1.00E-01,1.50E-01,2.00E-01,3.00E-01,4.00E-01,5.00E-01,6.00E-01,8.00E-01,1.00E+00 };
double g_WtPe[25] = { 4.08E+03,1.37E+03,6.16E+02,1.92E+02,8.20E+01,4.19E+01,2.41E+01,9.92E+00,4.94E+00,1.37E+00,5.44E-01,1.46E-01,5.68E-02,2.73E-02,1.49E-02,5.77E-03,2.76E-03,7.31E-04,2.89E-04,8.16E-05,3.49E-05,1.88E-05,1.17E-05,5.92E-06,3.68E-06 };
double g_WtSc[25] = { 1.37E+00,1.27E+00,1.15E+00,9.09E-01,7.08E-01,5.58E-01,4.49E-01,3.10E-01,2.31E-01,1.33E-01,8.86E-02,4.69E-02,2.87E-02,1.94E-02,1.39E-02,8.17E-03,5.35E-03,2.44E-03,1.39E-03,6.22E-04,3.51E-04,2.25E-04,1.56E-04,8.79E-05,5.63E-05 };
double g_WtSi[25] = { 1.32E-02,2.67E-02,4.18E-02,7.08E-02,9.43E-02,1.12E-01,1.26E-01,1.44E-01,1.55E-01,1.70E-01,1.77E-01,1.83E-01,1.83E-01,1.80E-01,1.77E-01,1.70E-01,1.63E-01,1.47E-01,1.35E-01,1.18E-01,1.06E-01,9.66E-02,8.94E-02,7.86E-02,7.07E-02 };


// vg^Cv錾
double reference_linear(double E, double* en, double* dn);
int interaction(double eg, double t, double mu, double dpe, double dsc);
void seed_xor128(unsigned long s);
double dxor128();

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%f] :", menu[i++], g_eg);
	if (*fgets(dat, 256, stdin) != '\n')  g_eg = atof(dat);
	printf(" %s [%f] :", menu[i++], g_t);
	if (*fgets(dat, 256, stdin) != '\n')  g_t  = atof(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atol(dat);
	printf(" %s [%d] :", menu[i++], g_sr);
	if (*fgets(dat, 256, stdin) != '\n')  g_sr = atoi(dat);

	printf("\n");
}

int main(void)
{
	int i;
	double  mu;  // Wifʐς̍vj
	double  dsc; // U̒fʐ
	double  dsi; // 񊱏U̒fʐ
	double  dpe; // dʂ̒fʐρizj
	int c[4] = { 0,0,0,0 };  // [0], z[1], U[2]C񊱏U[3]̌q

	getparameter();

	// ̏
	seed_xor128(g_sr);

	// qGlM[keVMeV
	g_eg /= 1000;

	// dʂ̒fʐ
	dpe = reference_linear(g_eg, g_WtEn, g_WtPe);
	printf("dʁ@@F%f cm^2/g\n", dpe);

	// U̒fʐώZo
	dsc = reference_linear(g_eg, g_WtEn, g_WtSc);
	printf("U@F%f cm^2/g\n", dsc);

	// 񊱏U̒fʐώZo
	dsi = reference_linear(g_eg, g_WtEn, g_WtSi);
	printf("񊱏UF%f cm^2/g\n", dsi);

	// W
	mu = dpe + dsc + dsi;
	printf("W@F%f cm^-1\n\n", mu);

	// q̌JԂ
	for (i = 0; i < g_nn; i++)
	{
		// ݍpʂ̃JEg
		c[interaction(g_eg, g_t, mu, dpe, dsc)]++;
	}

	printf("ߌq@@@F%d \n", c[0]);
	printf("dʁizjF%d \n", c[1]);
	printf("U@@@F%d \n", c[2]);
	printf("񊱏U@@F%d \n", c[3]);
	printf("\n");

	return 0;
}

// GlM[`ԂĒfʐςvZ
// double E;  // q̃GlM[
// double en; // GlM[z
// double dn; // fʐϔz
double reference_linear(double E, double* en, double* dn)
{
	int    i;
	double sg = 0; // Zofʐ

	// `Ԉʒl̎Zo
	for (i = 0; i < 25; i++)
	{
		if (E - en[i] <= 0) break;
	}

	if (i > 0 && i < 25) // `ԂŒfʐςZo
		sg = dn[i - 1] + ((dn[i] - dn[i - 1]) * ((E - en[i - 1]) / (en[i] - en[i - 1])));

	return sg;
}

// *** ݍp̑Iij ***
// double  eg;  // ˌq̃GlM[ (keV)
// double  t;   // ʑ̂̒ ticmj
// double  mu;  // W
// double  dpe; // dʂ̒fʐ
// double  dsc; // U̒fʐ
int interaction(double eg, double t, double mu, double dpe, double dsc)
{
	double  d;   // Rs

	// RšvZ
	d = -1 / mu*log(1 - dxor128());

	if (d > t) return 0; // q
	else
	{   // zƎU̔f
		double r = mu*dxor128(); // l R[0, mu]
		if (r < dpe)
			return 1; // qz
		else if (r < dpe + dsc)
			return 2; // qU
		else
			return 3; // q񊱏U
	}
}

// ***********************************************
// *** Xorshift^񐶐@iݒtj***
// ***********************************************

// p̔z
static unsigned long seed[4] = { 123456789, 362436069, 521288629, 88675123 };

// *** ̏ ***
// unsigned long  s;  // ilj
void seed_xor128(unsigned long s)
{
	for (unsigned long i = 0; i < 4; ++i) seed[i] = s = 1812433253U * (s ^ (s >> 30)) + i;
}

// *** [0,1]̈l ***
double dxor128(void)
{
	unsigned long *x = seed;
	unsigned long  t = (x[0] ^ (x[0] << 11));
	x[0] = x[1]; x[1] = x[2]; x[2] = x[3];
	x[3] = (x[3] ^ (x[3] >> 19)) ^ (t ^ (t >> 8));
	return x[3] / (double)(ULONG_MAX);
}
