#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char *title = "dʂ̃V~[Vij";
char *fname = "P3-03photoelectric.c";

// ̓j[
char *menu[] = {
	" 1/3. q̃GlM[ (keV)   ",
	" 2/3. q n@@@   ",
	" 3/3. l       ",
};

// O[oϐ̐錾Əlݒ
double  g_E0 = 100;           // 1Dq̃GlM[ (keV)
int     g_nn = 1000000;       // 2DUq n
unsigned long g_sr = 1;       // 3. l

double  g_th = 0;   // Upiradianj
double  g_ph = 0;   // ʊpiradianj
double  g_E1 = 0;   // Uq̃GlM[ikeVj

// (H20)̒萔
// Xidʁj
// g_WtCX[0]: 0.543;  // Kz[GlM[ikeVj
// g_WtCX[1]: 0.002;  // Xu
// g_WtCX[2]: 1.0;    // KkőݍpNm
// g_WtCX[3]: 1.0;    // Ka̔m
// g_WtCX[4]: 0.525;  // KǎqGlM[ (keV)
// g_WtCX[5]: 0.0;    // Kb̌qGlM[ (keV)
double  g_WtCX[6] = { 0.543, 0.002, 1.0, 1.0, 0.525, 0.0 };

// vg^Cv錾
int photoelectric(double *th, double *ph, double *E1, double E0, double *CX);
void seed_xor128(unsigned long s);
double dxor128();

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%f] :", menu[i++], g_E0);
	if (*fgets(dat, 256, stdin) != '\n')  g_E0 = atof(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_sr);
	if (*fgets(dat, 256, stdin) != '\n')  g_sr = atoi(dat);

	printf("\n");
}

int main(void)
{
	int  i;
	int  c[2] = { 0, 0 };

	getparameter();

	// ̏
	seed_xor128(g_sr);

	// q̌JԂ
	for (i = 0; i < g_nn; i++)
	{
		// ǓvZ
		if (photoelectric(&g_th, &g_ph, &g_E1, g_E0, g_WtCX) == 0)
			c[0]++; // z
		else
			c[1]++; // X
	}

	// zƓX̊
	printf("z @ F%d\n", c[0]);
	printf("X F%d\n", c[1]);

	return 0;
}

// *** d ***
// double  *th;   // UpƂ̏o(radian)
// double  *ph;   // ʊpӂ̏o(radian)
// double  *E1;   // X̃GlM[(keV)̏ói͂Ɠj
// double   E0;   // dʑÕGlM[(keV)
// double  *CX;   // X̒萔
int photoelectric(double *th, double *ph, double *E1, double E0, double *CX)
{
	double R1, R2, R3, rr, xy;

	// ߂l̏
	*th = 0; // Up
	*ph = 0; // ʊp
	*E1 = 0; // X̃GlM[

	if (E0 <= CX[0]) return 0; // ziKz[j

	R1 = dxor128();

	if (R1 > CX[1] * CX[2]) return 0; // ziuKkj

	R2 = dxor128();

	// XKaKb̌
	if (R2 < CX[3])
		*E1 = CX[4];
	else
		*E1 = CX[5];

	// Sʂ烉_ɑI
	while (1)
	{
		R1 = 2 * dxor128() - 1; // xW
		R2 = 2 * dxor128() - 1; // yW
		R3 = 2 * dxor128() - 1; // zW
		rr = R1 * R1 + R2 * R2 + R3 * R3;
		if (rr > 0 && rr < 1) break;
	}
	rr = sqrt(rr);
	xy = sqrt(R1 * R1 + R2 * R2);

	// --- UpƂ̌ --------------------------
	*th = acos(R3 / rr);

	// --- ʊpӂ̌ --------------------------
	*ph = acos(R1 / xy);

	return 1;
}

// ***********************************************
// *** Xorshift^񐶐@iݒtj***
// ***********************************************

// p̔z
static unsigned long seed[4] = { 123456789, 362436069, 521288629, 88675123 };

// *** ̏ ***
// unsigned long  s;  // ilj
void seed_xor128(unsigned long s)
{
	for (unsigned long i = 0; i < 4; ++i) seed[i] = s = 1812433253U * (s ^ (s >> 30)) + i;
}

// *** [0,1]̈l ***
double dxor128(void)
{
	unsigned long *x = seed;
	unsigned long  t = (x[0] ^ (x[0] << 11));
	x[0] = x[1]; x[1] = x[2]; x[2] = x[3];
	x[3] = (x[3] ^ (x[3] >> 19)) ^ (t ^ (t >> 8));
	return x[3] / (double)(ULONG_MAX);
}
