#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char *title = "UiC[Uj̃V~[V";
char *fname = "P3-04coherent.c";

// ̓j[
char *menu[] = {
	" 1/5. o3摜t@C  ",
	" 2/5. 摜̕ij         ",
	" 3/5. q̃GlM[ (keV)   ",
	" 4/5. Uq n@@@   ",
	" 5/5. l       ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n3-04coh.imv"; // 1. o3摜t@C
int     g_nx = 256;                // 2. 摜̕ij
double  g_E0 = 120;                // 3Dq̃GlM[ (keV)
int     g_nn = 100000;             // 4DUq n
unsigned long g_sr = 1;            // 5. l

double  g_th = 0;  // Upiradianj
double  g_ph = 0;  // ʊpiradianj
double  g_E1 = 0;  // Ǔq̃GlM[ikeVj

float  *g_img;     // o͗p3摜̈

// (H20)̒萔
// x(momentum transfer)Fm(x)̕ϊe[u
double g_WtXm[45] = { 0,0.005,0.01,0.015,0.02,0.025,0.03,0.04,0.05,0.07,0.09,0.1,0.125,0.15,0.175,0.2,0.25,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1,1.25,1.5,2,2.5,3,3.5,4,5,6,7,8,10,15,20,50,80,100,1000,1000000,1000000000 };
double g_WtFm[45] = { 10,9.9963,9.98678,9.97148,9.94932,9.92104,9.88668,9.80028,9.69126,9.41144,9.06146,8.86574,8.32902,7.75238,7.16282,6.58126,5.50418,4.58834,3.26398,2.476284,2.02515,1.76177,1.59737,1.482482,1.3900622,1.1879894,0.9990874,0.67297806,0.44210706,0.318598032,0.19520746,0.152463208,0.066925994,0.036512564,0.021106791,0.015803984,0.005201634,0.001287523,0.000419182,1.13896E-05,1.801E-06,7.53874E-07,1.44756E-10,7.8204E-20,7.9997E-29 };
double g_WtPh[45];

// vg^Cv錾
void mkphi(double* phi, double* xmt, double* fmx, int n);
void coherent(double* th, double* ph, double* E1, double E0, double* xmt, double* phi, int n);
void write_data(char *fi, float *img, int size);
void seed_xor128(unsigned long s);
double dxor128();

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat);	}
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_E0);
	if (*fgets(dat, 256, stdin) != '\n')  g_E0 = atof(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_sr);
	if (*fgets(dat, 256, stdin) != '\n')  g_sr = atoi(dat);

	printf("\n");
}

int main(void)
{
	int i, ix, iy, iz;
	double x, y, z, r;

	getparameter();

	// 摜̈̊m
	g_img = (float *)malloc((size_t)g_nx*g_nx*g_nx * sizeof(float));

	// 摜̏
	for (i = 0; i < g_nx*g_nx*g_nx; i++)
		g_img[i] = 0;

	// (x)f[^̍쐬
	mkphi(g_WtPh, g_WtXm, g_WtFm, 45);

	// ̏
	seed_xor128(g_sr);

	// o͉摜̋̔ǎ
	r = g_nx * 7 / 16;

	// q̌JԂ
	for (i = 0; i < g_nn; i++)
	{
		// ǓvZ
		coherent(&g_th, &g_ph, &g_E1, g_E0, g_WtXm, g_WtPh, 45);

		// Wnւ̕ϊ
		x = r*cos(g_ph)*sin(g_th); // x = r cos()sin()
		y = r*sin(g_ph)*sin(g_th); // y = r sin()sin()
		z = r*cos(g_th);           // z = r cos()

		// 摜Wւ̕ϊi_ȉľܓj
		ix = (int)(x + g_nx / 2 + 0.5);
		iy = (int)(g_nx / 2 - y + 0.5);
		iz = (int)(g_nx / 2 - z + 0.5);

		// 摜ł̃JEg
		g_img[iz*g_nx*g_nx + iy*g_nx + ix] += 1;
	}

	// U摜̏o
	write_data(g_f1, g_img, g_nx*g_nx*g_nx);
	
	// 摜̈̊J
	free(g_img);

	return 0;
}

// (x)f[^̍쐬
// double *phi; // (x)̃f[^z
// double *xmt; // GlM[ x ̃f[^z
// double *fmx; // Fm(x)̃f[^z
// int     n;   // f[^
void mkphi(double* phi, double* xmt, double* fmx, int n)
{
	int  i;
	double* f2x;
	f2x = (double*)malloc((size_t)n * sizeof(double));
	for (i = 0; i < n; i++)
	{
		f2x[i] = fmx[i] * fmx[i] * xmt[i];
	}
	phi[0] = f2x[0];
	for (i = 1; i < n; i++)
	{
		phi[i] = phi[i - 1] + (xmt[i] - xmt[i - 1]) * (f2x[i] + f2x[i - 1]) / 2;
	}
}

// *** 2̔z񂩂`ԂĖړIϐvZ ***
// double a0;  // Ώۂ̒l
// double *a;  // ړIϐɑΉΏەϐ̔z
// double *b;  // `ԂړIϐ̔z
// int    n;   // z̗vf
double reference_linear(double a0, double *a, double *b, int n)
{
	int     i;
	double  mu;

	for (i = 0; i < n; i++)
	{
		if (a0 - a[i] <= 0) break;
	}
	// `ԂŌWZo
	mu = b[i - 1] + ((b[i] - b[i - 1])*((a0 - a[i - 1]) / (a[i] - a[i - 1])));

	return mu;
}

// *** UiC[Uj***
// double  *th;   // UpƂ̏o(radian)
// double  *ph;   // ʊpӂ̏o(radian)
// double  *E1;   // ŨGlM[(keV)̏ói͂Ɠj
// double   E0;   // UÕGlM[(keV)
// double  *xmt;  // atomic form factor vZGlM[ x
// double  *phi   // atomic form factor vZ郳(x)̒l
// double   n;    // atomic form factor vZz̗vf
void coherent(double *th, double *ph, double *E1, double E0, double *xmt, double *phi, int n)
{
	double R1, fmax, fmin;
	double x, sin_th_2, cos_th;

	// atomic form factormax, min烉_Ō
	fmax = phi[n-1];
	fmin = phi[0];

	while (1)
	{
		// l R1[0, max]𐶐
		R1 = fmin + (fmax - fmin)*dxor128();

		// x (momentum transfer)
		x = reference_linear(R1, phi, xmt, n);

		// sin(/2)̎Zo(E0:keV)
		sin_th_2 = x*(12.398420 / E0);

		// Ol̏
		if (sin_th_2 > 1.0) continue;

		// cos  ̎Zo
		cos_th = 1 - 2 * sin_th_2*sin_th_2;

		// R2[0, 2]1+cos^2Ƃ̔r
		if (2 * dxor128() <= 1 + cos_th*cos_th) break;
	}

	// --- UpƂ̌ -------------------------------------
	*th = 2 * asin(sin_th_2);
	//fprintf(stderr, "R1=%f, x=%f, st2=%f, th=%f\n", R1, x, sin_th_2, *th*180/PI);

	// --- ʊpӂ͈l R3[0, 2]茈 --------------
	*ph = 2 * PI*dxor128();

	// --- ŨGlM[ ---------------------------
	// Rq[g͂قƂǃGlM[Ȃ̂œɂ
	*E1 = E0;
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char *fi, float *img, int size)
{
	FILE   *fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}

// ***********************************************
// *** Xorshift^񐶐@iݒtj***
// ***********************************************

// p̔z
static unsigned long seed[4] = { 123456789, 362436069, 521288629, 88675123 };

// *** ̏ ***
// unsigned long  s;  // ilj
void seed_xor128(unsigned long s)
{
	for (unsigned long i = 0; i < 4; ++i) seed[i] = s = 1812433253U * (s ^ (s >> 30)) + i;
}

// *** [0,1]̈l ***
double dxor128(void)
{
	unsigned long *x = seed;
	unsigned long  t = (x[0] ^ (x[0] << 11));
	x[0] = x[1]; x[1] = x[2]; x[2] = x[3];
	x[3] = (x[3] ^ (x[3] >> 19)) ^ (t ^ (t >> 8));
	return x[3] / (double)(ULONG_MAX);
}
