#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char *title = "񊱏UiRvgUj̃V~[V";
char *fname = "P3-05incoherent.c";

// ̓j[
char *menu[] = {
	" 1/5. o3摜t@C  ",
	" 2/5. 摜̕ij         ",
	" 3/5. q̃GlM[ (keV)   ",
	" 4/5. Uq n@@@   ",
	" 5/5. l       ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n3-05inc.imv"; // 1. o3摜t@C
int     g_nx = 256;                // 2. 摜̕ij
double  g_E0 = 120;                // 3Dq̃GlM[ (keV)
int     g_nn = 10000000;           // 4DUq n
unsigned long g_sr = 1;            // 5. l

double  g_th = 0;  // Upiradianj
double  g_ph = 0;  // ʊpiradianj
double  g_E1 = 0;  // Ǔq̃GlM[ikeVj

float  *g_img;     // o͗p3摜̈

// (H20)̒萔
// x(momentum transfer)incoherent scattering function ̕ϊe[u
double g_WtXm[45] = { 0,0.005,0.01,0.015,0.02,0.025,0.03,0.04,0.05,0.07,0.09,0.1,0.125,0.15,0.175,0.2,0.25,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1,1.25,1.5,2,2.5,3,3.5,4,5,6,7,8,10,15,20,50,80,100,1000,1000000,1000000000 };
double g_WtSx[45] = { 0,0.0052094,0.0198196,0.045076,0.079788,0.124134,0.177756,0.311562,0.47764,0.89418,1.39258,1.66214,2.36252,3.06248,3.72672,4.3367,5.36886,6.16674,7.22296,7.81804,8.17174,8.40982,8.59554,8.7548,8.9009,9.21588,9.462,9.7642,9.8999,9.957,9.9807,9.991,9.9977,9.9993,9.9998,10,10,10,10,10,10,10,10,10,10 };

// vg^Cv錾
void incoherent(double* th, double* ph, double* E1, double E0, double* xmt, double* sxz, int n);
void write_data(char *fi, float *img, int size);
void seed_xor128(unsigned long s);
double dxor128();

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat);	}
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_E0);
	if (*fgets(dat, 256, stdin) != '\n')  g_E0 = atof(dat);
	printf(" %s [%d] :", menu[i++], g_nn);
	if (*fgets(dat, 256, stdin) != '\n')  g_nn = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_sr);
	if (*fgets(dat, 256, stdin) != '\n')  g_sr = atoi(dat);

	printf("\n");
}

int main(void)
{
	int i, ix, iy, iz;
	double x, y, z, r;

	getparameter();

	// 摜̈̊m
	g_img = (float *)malloc((size_t)g_nx*g_nx*g_nx * sizeof(float));

	// 摜̏
	for (i = 0; i < g_nx*g_nx*g_nx; i++)
		g_img[i] = 0;

	// ̏
	seed_xor128(g_sr);

	// o͉摜̋̔ǎ
	r = g_nx / 4;

	// q̌JԂ
	for (i = 0; i < g_nn; i++)
	{
		// ǓvZ
		incoherent(&g_th, &g_ph, &g_E1, g_E0, g_WtXm, g_WtSx, 45);

		// Wnւ̕ϊ
		x = r*cos(g_ph)*sin(g_th); // x = r cos()sin()
		y = r*sin(g_ph)*sin(g_th); // y = r sin()sin()
		z = r*cos(g_th);           // z = r cos()

	   // 摜Wւ̕ϊi_ȉľܓj
		ix = (int)(x + g_nx / 2 + 0.5);
		iy = (int)(g_nx / 2 - y + 0.5);
		iz = (int)(g_nx / 2 - z + 0.5);

		// 摜ł̃JEg
		g_img[iz*g_nx*g_nx + iy*g_nx + ix] += 1;
	}

	// U摜̏o
	write_data(g_f1, g_img, g_nx*g_nx*g_nx);
	
	// 摜̈̊J
	free(g_img);

	return 0;
}

// *** 2̔z񂩂`ԂĖړIϐvZ ***
// double a0;  // Ώۂ̒l
// double *a;  // ړIϐɑΉΏەϐ̔z
// double *b;  // `ԂړIϐ̔z
// int    n;   // z̗vf
double reference_linear(double a0, double *a, double *b, int n)
{
	int     i;
	double  mu;

	for (i = 0; i < n; i++)
	{
		if (a0 - a[i] <= 0) break;
	}
	// `ԂŌWZo
	mu = b[i - 1] + ((b[i] - b[i - 1])*((a0 - a[i - 1]) / (a[i] - a[i - 1])));

	return mu;
}

// *** 񊱏UiRvgUj***
// double  *th;   // UpƂ̏o(radian)
// double  *ph;   // ʊpӂ̏o(radian)
// double  *E1;   // ŨGlM[(keV)̏ói͂Ɠj
// double   E0;   // UÕGlM[(keV)
// double  *xmt;  // incoherent scattering function vZGlM[ x
// double  *sxz   // incoherent scattering function vZs(x,Z)̒l
// double   n;    // incoherent scattering function vZz̗vf
void incoherent(double *th, double *ph, double *E1, double E0, double *xmt, double *sxz, int n)
{
	double et;				// f()ɏ]
	double a = E0 / 511;	// E0511̒P(keV)͍킹
	double S, S_max = sxz[n-1];
	double R1, R2, R3, R4;
	double sin_th_2, cos_th, mu, x;

	while (1) 
	{
		// l R1, R2, R3[0,1]𐶐
		R1 = dxor128();
		R2 = dxor128();
		R3 = dxor128();

		if (R1 <= (2 * a + 1) / (2 * a + 9))
		{
			// łZo
			et = 2 * a * R2 + 1;
			if (R3 > 4 * ((1 / et) - (1 / (et*et))))
				continue;

			// cosƂ̎Zo
			cos_th = 1 - 2*R2;
		}
		else
		{
			// łZo
			et = (2 * a + 1) / (2 * R2 * a + 1);
			mu = 1 - (et - 1) / a;
			if (R3 > (mu * mu + 1 / et) / 2)
				continue;

			// cosƂ̎Zo
			cos_th = mu;
		}

		// cos   sin(/2)Zo
		sin_th_2 = sqrt((1 - cos_th) / 2);

		// sin(/2)ƃGlM[E0xZo
		x = sin_th_2 * E0 / 12.4;

		// xS̒lCe[ugČ
		S = reference_linear(x, xmt, sxz, n);

		// l R4[0,S_max]𐶐
		R4 = S_max * dxor128();
		if (R4 <= S) break;
	}

	// --- UpƂ̌ ---------------------
	*th = 2 * asin(sin_th_2);

	// --- ʊpӂ͈l R5[0, 2]茈 ---
	*ph = 2 * PI * dxor128();

	// --- ŨGlM[߂ ---------
	*E1 = E0 / et;
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char *fi, float *img, int size)
{
	FILE   *fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}

// ***********************************************
// *** Xorshift^񐶐@iݒtj***
// ***********************************************

// p̔z
static unsigned long seed[4] = { 123456789, 362436069, 521288629, 88675123 };

// *** ̏ ***
// unsigned long  s;  // ilj
void seed_xor128(unsigned long s)
{
	for (unsigned long i = 0; i < 4; ++i) seed[i] = s = 1812433253U * (s ^ (s >> 30)) + i;
}

// *** [0,1]̈l ***
double dxor128(void)
{
	unsigned long *x = seed;
	unsigned long  t = (x[0] ^ (x[0] << 11));
	x[0] = x[1]; x[1] = x[2]; x[2] = x[3];
	x[3] = (x[3] ^ (x[3] >> 19)) ^ (t ^ (t >> 8));
	return x[3] / (double)(ULONG_MAX);
}
