#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

// vO̐
char *fname = "P4-06sinogram.c";
char *title = "3Def[^TCmO쐬vO";

// ̓j[
char *menu[] = {
	" 1/6. 3Def[^̃t@C ",
	" 2/6. 2Def[^̃t@C ",
	" 3/6. ef[^̕           ",
	" 4/6. ef[^̍         ",
	" 5/6. ef[^̓e       ",
	" 6/6. XCXʒu             ",
};

// O[oϐ̐錾Əlݒ
char  g_f1[50] = "n4-05_0all.imv";  // 1D3Def[^̃t@C
char  g_f2[50] = "n4-06_0all.prj";  // 2D3Def[^̃t@C
int   g_px = 128;                   // 3Def[^̕
int   g_pz = 128;                   // 4Def[^̍
int   g_pa = 128;                   // 5. ef[^̓e
int   g_sn = 64;                    // 6. XCXʒu

float*  g_prj;                      // 3Def[^̈
float*  g_pr2;                      // 2Def[^̈

// vg^Cv錾
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pz);
	if (*fgets(dat, 256, stdin) != '\n')  g_pz = atol(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_sn);
	if (*fgets(dat, 256, stdin) != '\n')  g_sn = atol(dat);

	printf("\n");
}

int main(void)
{
	int i, j;

	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));
	g_pr2 = (float*)malloc((size_t)g_px * g_pa * sizeof(float));
	for (i = 0; i < g_px * g_pz * g_pa; i++)
		g_prj[i] = 0;
	for (i = 0; i < g_px * g_pa; i++)
		g_pr2[i] = 0;

	// 3Def[^̕ۑ
	read_data(g_f1, g_prj, g_px * g_pz * g_pa);

	// TCmO̍쐬
	for (i = 0; i < g_pa; i++) {
		for (j = 0; j < g_px; j++) {
			g_pr2[i * g_px + j] = g_prj[i * g_px * g_pz + g_sn * g_px + j];
		}
	}

	// ef[^̕ۑ
	write_data(g_f2, g_pr2, g_px * g_pa);

	// 摜̈̊J
	free(g_prj);
	free(g_pr2);

	return 0;
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
