#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define  PI  3.14159265358979

// vO̐
char* fname = "P4-09chang.c";
char* title = "Chang@ōč\摜␳vO";

// ̓j[
char* menu[] = {
	" 1/7. ␳Ỏ摜f[^̃t@C  ",
	" 2/7. ␳̉摜f[^̃t@C  ",
	" 3/7. 摜f[^̕        ",
	" 4/7. 摜f[^̍      ",
	" 5/7. ~̔a  icmj      ",
	" 6/7. sNZicmj      ",
	" 7/7. Wi1/cmj    ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-07_4all.img";  // 1. ␳Ỏ摜f[^̃t@C
char    g_f2[50] = "n4-09_0all.img";  // 2. ␳̉摜f[^̃t@C
int     g_nx = 128;                   // 3. ef[^̃r
int     g_ny = 128;                   // 4. ef[^̓e
double  g_cr = 10;                    // 5. ~̔aicmj
double  g_pl = 32.0 / 128;            // 6. sNZicmj
double  g_mu = 0.15;                  // 7DWi1/cmj

float* g_img;  // 摜f[^̈

// vg^Cv錾
void chang(float* img, int nx, int ny, double r, double pl, double mu);
void read_data(char*, float*, int);
void write_data(char*, float*, int);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_cr);
	if (*fgets(dat, 256, stdin) != '\n')  g_cr = atof(dat);
	printf(" %s [%f] :", menu[i++], g_pl);
	if (*fgets(dat, 256, stdin) != '\n')  g_pl = atof(dat);
	printf(" %s [%f] :", menu[i++], g_mu);
	if (*fgets(dat, 256, stdin) != '\n')  g_mu = atof(dat);

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊mۂƏ
	g_img = (float*)malloc((size_t)g_nx * g_ny * sizeof(float));

	// 摜f[^̓ǂݏo
	read_data(g_f1, g_img, g_nx * g_ny);

	// Chang@ɂ␳
	chang(g_img, g_nx, g_ny, g_cr, g_pl, g_mu);

	// ␳̓ef[^̕ۑ
	write_data(g_f2, g_img, g_nx * g_ny);

	// 摜̈̊J
	free(g_img);

	return 0;
}

// Chanǧ␳@ŉ摜f[^␳֐
// float    *img;   // 摜f[^
// int      nx;     // 摜f[^̕
// int      ny;     // 摜f[^̍
// double   r;      // ~̔a  icmj
// double   pl;     // sNZicmj
// double   mu;     // Wi1/cmj
void chang(float* img, int nx, int ny, double r, double pl, double mu)
{
	int     i, j, k;
	int     px = nx;  // S̗֊s߂ۂ̕
	int     pa = nx;  // px݁i360xj
	double  s = 0;    // S֊s܂ł̋
	float* sxt;  // S֊s܂ł̒
	float* cmx;  // ␳}gNX
	float* msk;  // }XN摜

	// ~̒[܂ł̒
	sxt = (float*)malloc((size_t)px * pa * sizeof(float));
	for (i = 0; i < px; i++) {
		double x = (i - px / 2) * pl;
		double d = r * r - x * x;
		if (d > 0) sxt[i] = (float)sqrt(d);
		else       sxt[i] = 0;
	}
	for (i = 1; i < pa; i++) {
		for (j = 0; j < px; j++) {
			sxt[i * px + j] = sxt[j];
		}
	}
	write_data("n4-09_2sxt.prj", sxt, px * pa);

	// ␳}gbNXƃ}XN摜̎Zo
	cmx = (float*)malloc((size_t)nx * ny * sizeof(float));
	msk = (float*)malloc((size_t)nx * ny * sizeof(float));
	for (i = 0; i < nx * ny; i++) {
		cmx[i] = 0;
		msk[i] = 1;
	}
	// te𗘗p
	for (k = 0; k < pa; k++) {
		double th = 2 * PI * k / pa;
		double si = sin(th);
		double co = cos(th);
		for (i = 0; i < ny; i++) {
			double y = ny / 2 - i;
			for (j = 0; j < nx; j++) {
				double x = j - nx / 2;
				double xx = x * co + y * si + px / 2;
				int ix0 = (int)floor(xx);
				int ix1 = ix0 + 1;
				double dx0 = xx - ix0;
				double dx1 = 1 - dx0;
				if (ix0 < 0 || ix1 > px - 1) continue;
				s = dx0 * sxt[k * px + ix1] + dx1 * sxt[k * px + ix0];
				cmx[i * nx + j] += (float)exp(-mu * s);
				if (s == 0) msk[i * nx + j] = 0;
			}
		}
	}
	// tZƃ}XN摜̏Z
	for (i = 0; i < nx * ny; i++)
		if(cmx[i] != 0)
			cmx[i] = pa / cmx[i] * msk[i];
	write_data("n4-09_3cmx.img", cmx, nx * ny);
	write_data("n4-09_4msk.img", msk, nx * ny);

	// ␳}gbNXɂ摜̕␳
	for(i = 0 ; i < nx*ny ; i++)
	        img[i] *= cmx[i];

	free(sxt);
	free(cmx);
	free(msk);
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
