#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char* fname = "P4-17exp_const.c";
char* title = "U֐̌W肷邽߂̃vO";

// ̓j[
char* menu[] = {
	" 1/2. PSF̃t@C  ",
	" 2/2. PSF̕    @@      ",
};

// O[oϐ
char    g_f1[50] = "n4-16_psf.csv";     // ̓t@CiCSVt@Cj
int     g_nx=128;  // f[^
double  g_cst[4];  // 萔a,b,c,d

// VvbNX@p̏l
double  g_cf[5][4] = { {0.02,0.1,0.1,0.1},{0.03,0.1,0.09,0.1},{0.015,0.1,0.105,0.1},{0.02,0.15,0.1,0.1},{0.02,1,0.1,0.15} };

double* g_psf;     // PSFf[^̈

// vg^Cv錾
void read_data_csv(char* fi, double* csv, int size);
void exp_const(double* cst);
int	simp(double** p, double* y, int ndim, double ftol, double (*funk)(double*));

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);

	printf("\n");
}

int main(void)
{
	int i;

	getparameter();

	// ̈̊mۂƏ
	g_psf = (double*)malloc((size_t)g_nx * sizeof(double));

	// ef[^̓ǂݏo
	read_data_csv(g_f1, g_psf, g_nx);

	// PSF̎Zo
	exp_const(g_cst);

	// 萔̕\
	printf("萔a = %f\n", g_cst[0]);
	printf("萔b = %f\n", g_cst[1]);
	printf("萔c = %f\n", g_cst[2]);
	printf("萔d = %f\n", g_cst[3]);

	// 摜̈̊J
	free(g_psf);

	return 0;
}

// *** CSVf[^i1̃eLXgf[^j̓ ***
// char *fi;     // ̓f[^̃t@C
// double *csv;  // ̓f[^
// int  size;    // ̓f[^̃TCY
void read_data_csv(char* fi, double* csv, int size)
{
	int   i;
	char  dat[256];
	FILE* fp;

	if ((fp = fopen(fi, "r")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	for (i = 0; i < size; i++) {
		fgets(dat, 256, fp);
		csv[i] = atof(dat);
	}
	fclose(fp);
}

// *** 덷̎Zo ***
// double* af;  // œKlZoϐz
double sqerr(double* af)
{
	int     i;
	double	err = 0;

	// 덷
	for (i = 0; i < g_nx; i++) {
		double x = i - g_nx / 2;
		double s = af[0] * exp(-af[1] * fabs(x)) + af[2] * exp(-af[3] * x * x);
		err += (s - g_psf[i]) * (s - g_psf[i]);
	}

	return(err);
}

// *** VvbNX@ɂœKl̎Zo ***
// double* cst;  // œKlZoϐz
void exp_const(double* cst)
{
	int      i, j;
	int      d = 4;         // m
	double	 eps = 0.00001; // G[̍ŏl
	double** p, * pp, * y;

	p = (double**)malloc((size_t)(d + 1) * sizeof(double*));
	pp = (double*)malloc((size_t)(d + 1) * d * sizeof(double));
	y = (double*)malloc((size_t)(d + 1) * sizeof(double));

	for (i = 0; i < d + 1; i++)
		p[i] = pp + i * d;

	for (i = 0; i < d + 1; i++)
		for (j = 0; j < d; j++)
			p[i][j] = 0;

	//l̑
	for (i = 0; i < 5; i++) {
		for (j = 0; j < 4; j++) {
			p[i][j] = g_cf[i][j];
		}
	}

	//l^G[l̎Zo
	for (i = 0; i < d + 1; i++)
		y[i] = sqerr(p[i]);

	//Simplex@ɂœK
	simp(p, y, d, eps, sqerr);

	//ʂ̑
	for (i = 0; i < 4; i++)
		cst[i] = p[0][i];

	free(pp);
	free(p);
	free(y);
}

//Simplex@
#define  MAX_LOOP 1000		/*őJԂ*/

//Simplex@֐
double amotry(double** p, double* y, double* psum, int ndim, double (*funk)(double*), int ihi, double fac)
{
	int     j;
	double  fac1, fac2, ytry, * ptry;

	ptry = (double*)malloc((size_t)ndim * sizeof(double));
	fac1 = (1.0 - fac) / ndim;
	fac2 = fac1 - fac;
	for (j = 0; j < ndim; j++)
		ptry[j] = psum[j] * fac1 - p[ihi][j] * fac2;
	ytry = (*funk)(ptry);
	if (ytry < y[ihi]) {
		y[ihi] = ytry;
		for (j = 0; j < ndim; j++) {
			psum[j] += ptry[j] - p[ihi][j];
			p[ihi][j] = ptry[j];
		}
	}
	free(ptry);
	return  ytry;
}

//ϐ̒l
void swap(double* a, double* b)
{
	double c;
	c = *a;
	*a = *b;
	*b = c;
}

//Simplex@̎s֐
int	simp(double** p, double* y, int ndim, double ftol, double (*funk)(double*))
{
	int     i, ihi, ilo, inhi, j, mpts = ndim + 1, nfunk = 0;
	double  rtol, sum, ysave, ytry, * psum;

	psum = (double*)malloc((size_t)ndim * sizeof(double));
	for (j = 0; j < ndim; j++) {
		for (sum = 0.0, i = 0; i < mpts; i++) sum += p[i][j];
		psum[j] = sum;
	}
	while (1) {
		ilo = 0;
		ihi = y[0] > y[1] ? (inhi = 1, 0) : (inhi = 0, 1);
		for (i = 0; i < mpts; i++) {
			if (y[i] <= y[ilo]) ilo = i;
			if (y[i] > y[ihi]) {
				inhi = ihi;
				ihi = i;
			}
			else if (y[i] > y[inhi] && i != ihi)
				inhi = i;
		}

		/* Ip̒l̎Zoi3̍W̍őlƍŏlƂ̍j*/
		rtol = fabs(y[ihi] - y[ilo]);
		//fprintf(stderr, "\r--- simplex [%3d] rtol : %f value : %f", nfunk, rtol, y[ilo]);

		if (rtol < ftol) {
			swap(y, y + ilo);
			for (i = 0; i < ndim; i++)
				swap(p[0] + i, p[ilo] + i);
			break;
		}

		if (nfunk >= MAX_LOOP) {
			fprintf(stderr, "Error: NMAX exceeded. \n");
			exit(1);
		}

		nfunk += 2;

		ytry = amotry(p, y, psum, ndim, funk, ihi, -1.0);
		if (ytry <= y[ilo])
			ytry = amotry(p, y, psum, ndim, funk, ihi, 2.0);
		else if (ytry >= y[inhi]) {
			ysave = y[ihi];
			ytry = amotry(p, y, psum, ndim, funk, ihi, 0.5);
			if (ytry >= ysave) {
				for (i = 0; i < mpts; i++) {
					if (i != ilo) {
						for (j = 0; j < ndim; j++)
							p[i][j] = psum[j] = 0.5 * (p[i][j] + p[ilo][j]);
						y[i] = (*funk)(psum);
					}
				}
				nfunk += ndim;
				for (j = 0; j < ndim; j++) {
					for (sum = 0.0, i = 0; i < mpts; i++) sum += p[i][j];
					psum[j] = sum;
				}
			}
		}
		else
			--nfunk;
	}
	//fprintf(stderr, "\n");
	free(psum);
	return nfunk;
}
