#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define  PI  3.14159265358979

// vO̐
char *fname = "P4-19tdcs.c";
char *title = "TDCS@ŕ␳vO";

// ̓j[
char *menu[] = {
	" 1/10. ef[^̃t@C ",
	" 2/10. e̕    ",
	" 3/10. e̍  ",
	" 4/10. e      ",
	" 5/10. ߌ^CTf[^̃t@C ",
	" 6/10. 摜̕    ",
	" 7/10. 摜̍  ",
	" 8/10. 摜̉s  ",
	" 9/10. ẑȂel ",
	"10/10. U␳ef[^̃t@C ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-07_0all.imv";  // 1Def[^̃t@C
int     g_px = 128;                   // 2De̕
int     g_pz = 128;                   // 3De̍
int     g_pa = 128;                   // 4De
char    g_f2[50] = "n4-18_tct.imv";   // 5Dߌ^CTf[^̃t@C
int     g_nx = 128;                   // 6D摜̕
int     g_ny = 128;                   // 7D摜̍
int     g_nz = 128;                   // 8D摜̉s
int     g_c0 = 10000;                 // 9DẑȂel
char    g_f3[50] = "n4-19_all.imv";   // 10DU␳ef[^̃t@C

float*  g_prj;  // ef[^̈
float*  g_img;  // W}bṽf[^̈ 

// vg^Cv錾
void tdcs(float* prj, int px, int pz, int pa, float* img, int nx, int ny, int nz);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_pz);
	if (*fgets(dat, 256, stdin) != '\n')  g_pz = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nz);
	if (*fgets(dat, 256, stdin) != '\n')  g_nz = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_c0);
	if (*fgets(dat, 256, stdin) != '\n')  g_c0 = atoi(dat);
	printf(" %s [%s] :", menu[i++], g_f3);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f3, dat); }

	printf("\n");
}

int main(void)
{
	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float*)malloc((size_t)g_px * g_pz * g_pa * sizeof(float));
	g_img = (float*)malloc((size_t)g_nx * g_ny * g_nz * sizeof(float));

	// ef[^̐W}bv̓ǂݏo
	read_data(g_f1, g_prj, g_px * g_pz * g_pa);
	read_data(g_f2, g_img, g_nx * g_ny * g_nz);

	// TDCS@ɂ␳
	tdcs(g_prj, g_px, g_pz, g_pa, g_img, g_nx, g_ny, g_nz);

	// PSFf[^̕ۑ
	write_data(g_f3, g_prj, g_px * g_pz * g_pa);

	// 摜̈̊J
	free(g_prj);
	free(g_img);

	return 0;
}

// *** U֐̏ݍ ***
// float  *prs;  // ݍ݌̓ef[^
// float  *prj;  // ef[^
// int     px;   // e̕
// int     pz;   // e̍
// int     pa;   // e
void convolution(float* prs, float* prj, int px, int pz, int pa)
{
	int     i, j, k, ii, jj;
	double  x, x2, s, t0, t1;

	// U֐̌W
	double  a = 0.013423;
	double  b = 0.067791;
	double  c = 0.106577;
	double  d = 0.099052;

	// 
	for (i = 0; i < px * pz * pa; i++)
		prs[i] = 0;

	// ݍ
	for (i = 0; i < pz; i++)
	{
		fprintf(stderr, "\rConvolution [%3d/%3d]", i, pz);
		for (j = 0; j < px; j++)
		{
			for (ii = i - pz / 4; ii < i + pz / 4; ii++)
			{
				if (ii < 0 || ii > pz - 1) continue;
				for (jj = j - px / 4; jj < j + px / 4; jj++)
				{
					if (jj < 0 || jj > px - 1) continue;
					x2 = (i - ii) * (i - ii) + (j - jj) * (j - jj);
					x = sqrt(x2);
					s = a * exp(-b * x) + c * exp(-d * x2);
					for (k = 0; k < pa; k++)
						prs[k * px * pz + i * px + j] += (float)(prj[k * px * pz + ii * px + jj] * s);
				}
			}
		}
	}
	fprintf(stderr, "\rConvolution [%3d/%3d]\n", i, pz);
	// pxƂ̍v̒
	for (k = 0; k < pa; k++) {
		t0 = t1 = 0;
		for (i = 0; i < px * pz; i++)
		{
			t0 += prj[k * px * pz + i];
			t1 += prs[k * px * pz + i];
		}
		t0 /= t1;
		for (i = 0; i < px * pz; i++)
			prs[k * px * pz + i] *= (float)t0;
	}
}

// *** TDCS@ŎU␳֐ ***
// float  *prj;  // ef[^
// int     px;   // e̕
// int     pz;   // e̍
// int     pa;   // e
// float  *img;  // W}bv
// int     nx;   // 摜̕
// int     ny;   // 摜̍
// int     nz;   // 摜̉s (nz = pz)
void tdcs(float* prj, int px, int pz, int pa, float* img, int nx, int ny, int nz)
{
	int     i;
	double  a = 3.6;
	double  b = a - 1;
	double  beta = 0.15;
	double  k0 = 0.214129;
	float*  prs;  // U֐ݍ񂾃f[^̈

	prs = (float*)malloc((size_t)px * pz * pa * sizeof(float));

	// U֐̏ݍ
	convolution(prs, prj, px, pz, pa);
	write_data("n4-19_1prs.imv", prs, g_px * g_pz * g_pa);

	// Uf[^̎Zo
	for (i = 0; i < px * pz * pa; i++)
		prs[i] *= (float)(1 - 1 / (a - b * pow(prj[i]/g_c0, beta / 2) + k0));
	write_data("n4-19_2prs.imv", prs, g_px * g_pz * g_pa);

	// Uf[^vC}f[^쐬
	for (i = 0; i < px * pz * pa; i++) {
		prj[i] -= prs[i];
		if (prj[i] < 0.0) prj[i] = 0;
	}

	free(prs);
}

// *** 摜f[^̓́ifloat^Ƃḗj***
// char *fi;    // ͉摜̃t@C
// float *img;  // ͉摜f[^
// int  size;   // ͉摜̃TCY
void read_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fread(img, sizeof(float), size, fp);
	fclose(fp);
}

// *** 摜f[^̏óifloat^Ƃďój***
// char *fi;    // o͉摜̃t@C
// float *img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
