#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define  PI  3.14159265358979

// vO̐
char* fname = "P4-21fdr_filter.c";
char* title = "FDR𗘗pČo␳vO";

// ̓j[
char* menu[] = {
	" 1/9. ef[^̃t@C         ",
	" 2/9. ␳ef[^̃t@C ",
	" 3/9. e̕                  ",
	" 4/9. e                    ",
	" 5/9. sNZicm/pixelj    ",
	" 6/9. R[^̊J (cm)     ",
	" 7/9. R[^̍ (cm)     ",
	" 8/9. o|]S (cm) ",
	" 9/9. SNR̒l                   ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n4-20_0all.prj";  // 1Def[^̃t@C
char    g_f2[50] = "n4-21_0all.prj";  // 2D␳ef[^t@C
int     g_px = 128;                   // 3De̕
int     g_pa = 128;                   // 4De
double  g_pl = 0.25;                  // 5. õsNZ (32.0 cm / 128 pixel)
double  g_cw = 0.25;                  // 6. R[^̌ (cm)(LEGP Collimator)
double  g_ch = 4.3;                   // 7. R[^̍ (cm)(LEGP Collimator)
double  g_cd = 20.0;                  // 8. o킩]S܂ł̋icmj
double  g_sn = 50.0;                  // 9. SNR (signal to noise ratio)

float* g_prj;  // ef[^̈
float* g_pri;  // ef[^̈() 
float* g_fdr;

// vg^Cv錾
void fft2d(int ir, float* imr, float* imi, int nx, int ny);
void fdr_filter(float* fdr, int nx, int na, double pl, double cw, double ch, double cd, double sn);
void read_data(char* fi, float* img, int size);
void write_data(char* fi, float* img, int size);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f2, dat); }
	printf(" %s [%d] :", menu[i++], g_px);
	if (*fgets(dat, 256, stdin) != '\n')  g_px = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_pa);
	if (*fgets(dat, 256, stdin) != '\n')  g_pa = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_pl);
	if (*fgets(dat, 256, stdin) != '\n')  g_pl = atof(dat);
	printf(" %s [%f] :", menu[i++], g_cw);
	if (*fgets(dat, 256, stdin) != '\n')  g_cw = atof(dat);
	printf(" %s [%f] :", menu[i++], g_ch);
	if (*fgets(dat, 256, stdin) != '\n')  g_ch = atof(dat);
	printf(" %s [%f] :", menu[i++], g_cd);
	if (*fgets(dat, 256, stdin) != '\n')  g_cd = atof(dat);
	printf(" %s [%f] :", menu[i++], g_sn);
	if (*fgets(dat, 256, stdin) != '\n')  g_sn = atof(dat);

	printf("\n");
}

int main(void)
{
	int   i;

	getparameter();

	// 摜̈̊mۂƏ
	g_prj = (float*)malloc((size_t)g_px * g_pa * sizeof(float));
	g_pri = (float*)malloc((size_t)g_px * g_pa * sizeof(float));
	g_fdr = (float*)malloc((size_t)g_px * g_pa * sizeof(float));
	for (i = 0; i < g_px * g_pa; i++) {
		g_pri[i] = 0;
		g_fdr[i] = 1;
	}

	// ef[^̐W}bv̓ǂݏo
	read_data(g_f1, g_prj, g_px * g_pa);

	// 2t[Gϊ
	fft2d(1, g_prj, g_pri, g_px, g_pa);

	write_data("n4-21_1prf.img", g_prj, g_px * g_pa);

	// FDRɂEBi[tB^̍쐬
	fdr_filter(g_fdr, g_px, g_pa, g_pl, g_cw, g_ch, g_cd, g_sn);

	// tB^
	for (i = 0; i < g_px * g_pa; i++) {
		g_prj[i] *= g_fdr[i];
		g_pri[i] *= g_fdr[i];
	}

	write_data("n4-21_2prf.img", g_prj, g_px * g_pa);
	write_data("n4-21_3fdr.img", g_fdr, g_px * g_pa);

	// 2t[Gtϊ
	fft2d(-1, g_prj, g_pri, g_px, g_pa);

	// PSFf[^̕ۑ
	write_data(g_f2, g_prj, g_px * g_pa);

	// 摜̈̊J
	free(g_prj);
	free(g_pri);

	return 0;
}

// *** FDR𗘗pEBi[tB^̍쐬 ***
// float   *fdr;  // FDR𗘗pEBi[tB^摜
// int      px;   // ef[^̕
// int      pa;   // e
// double   pl;   // sNZ (cm/pixel)
// double   cw;   // R[^̕icmj
// double   ch;   // R[^̍icmj
// double   dc;   // o킩]S܂ł̋icmj
// double   sn;   // Signal to Noise ratio (s/n) 
void fdr_filter(float* fdr, int px, int pa, double pl, double cw, double ch, double dc, double sn)
{
	int     i, j;
	double  n, w, dd, fw, ww;
	double  s = -cw * cw / (16 * ch * ch * log(2.0)); // KEX֐̌Œl

	for (i = 0; i < pa; i++) {
		n = i - pa / 2;
		for (j = px / 2 + 1; j < px; j++) {
			// pgiw=2*PI*uj
			w = 2 * PI * (j - px / 2) / (px * pl);
			dd = dc - n / w;
			if (dd < 0) dd = 0; // R[^͕̋lɂȂȂ
			fw = exp(s * dd * dd * w * w);
			// EBi[tB^
			ww = fw / (fw * fw + 1 / sn);
			fdr[i * px + j] = (float)ww;
			fdr[(pa - i - 1) * px + px - j] = (float)ww;
		}
	}
}

void read_data(char *fi, float *prj, int size)
{
	FILE   *fp;

	/* open file and read data */
	if((fp = fopen(fi, "rb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fread(prj, sizeof(float), size, fp);
	fclose(fp);
}

void write_data(char *fi, float *prj, int size)
{
	FILE   *fp;

	/* open file and write data */
	if((fp = fopen(fi, "wb")) == NULL) {
		fprintf( stderr," Error : file open [%s].\n", fi);
		exit(1);
	}
	fwrite(prj, sizeof(float), size, fp);
	fclose(fp);
}

// *** FFTɕKvȃf[^̍쐬iC]Cւpj***
// int     nx;        // 1FFT̃f[^
// double  *si;       // TCf[^   si[nx/2]
// double  *co;       // RTCf[^ co[nx/2]
// unsigned int *br;  // pf[^   brv[nx]
void FFTInit(int nx, double* si, double* co, unsigned int* br)
{
	int     i;
	double  dd = 2.0 * PI / nx;
	unsigned int  ur, ui, uc;

	// C]f[^̍쐬
	for (i = 0; i < nx / 2; i++) {
		si[i] = sin(dd * i);
		co[i] = cos(dd * i);
	}

	// ԓւpf[^̍쐬
	for (ui = 0; ui < (unsigned)nx; ui++) {
		ur = 0;
		for (uc = 1; uc <= (unsigned)nx / 2; uc <<= 1) {
			ur <<= 1;
			if ((ui & uc) != 0)
				ur++;
		}
		br[ui] = ur;
	}
}

/* 1t[GϊiFFTj */
// int     ir;        // ϊ(1)Ctϊ(-1)
// int     nx;        // 1FFT̃f[^
// double  *xr;       // ̃f[^   xr[nx]
// double  *xi;       // ̃f[^   xi[nx]
// double  *si;       // TCf[^   si[nx/2]
// double  *co;       // RTCf[^ co[nx/2]
// unsigned int *br;  // pf[^   br[nx]
void FFT(int ir, int nx, double* xr, double* xi, double* si, double* co, unsigned int* br)
{
	int     i, j, k, m, n1, n2 = nx, j3, j4, d = 1, g;
	double  a, b, c, s, tmp;

	// FFT̎sio^tCZj
	for (i = 1; i <= nx / 2; i *= 2, d += d) {
		g = 0;
		m = n2;
		n2 /= 2;
		for (k = 1; k <= n2; k++) {
			n1 = k - m;
			c = co[g];
			s = ir * si[g];
			g += d;
			for (j = m; j <= nx; j += m) {
				j3 = j + n1 - 1;
				j4 = j3 + n2;
				a = xr[j3] - xr[j4];
				b = xi[j3] - xi[j4];
				xr[j3] += xr[j4];
				xi[j3] += xi[j4];
				xr[j4] = c * a + s * b;
				xi[j4] = c * b - s * a;
			}
		}
	}

	// Ԃ̓ւ
	for (i = 0; i < nx; i++) {
		j = br[i];
		if (i < j) {
			tmp = xr[i];
			xr[i] = xr[j];
			xr[j] = tmp;
			tmp = xi[i];
			xi[i] = xi[j];
			xi[j] = tmp;
		}
	}

	// tϊ̏
	if (ir == -1) {
		for (i = 0; i < nx; i++) {
			xr[i] /= nx;
			xi[i] /= nx;
		}
	}
}

/* 2t[GϊiFFT𗘗pj */
// int     ir;        // ϊ(1)Ctϊ(-1)
// float  *imr;       // ̃f[^   imr[nx*ny]
// float  *imi;       // ̃f[^   imi[nx*ny]
// int     nx;        // 摜f[^̕
// int     ny;        // 摜f[^̍
void fft2d(int ir, float* imr, float* imi, int nx, int ny)
{
	int     i, j;

	// FFTɗpf[^z̐錾
	double* xr, * xi, * si, * co;
	unsigned int* br;

	// x̔z̊m
	xr = (double*)malloc((size_t)nx * sizeof(double));
	xi = (double*)malloc((size_t)nx * sizeof(double));
	si = (double*)malloc((size_t)nx / 2 * sizeof(double));
	co = (double*)malloc((size_t)nx / 2 * sizeof(double));
	br = (unsigned int*)malloc((size_t)nx * sizeof(unsigned int));

	// FFTɕKvȃf[^̍쐬
	FFTInit(nx, si, co, br);

	// x̃t[Gϊ
	for (i = 0; i < ny; i++) {
		// f[^̓ւi_擪Ɉړj
		for (j = 0; j < nx / 2; j++) {
			xr[j] = imr[i * nx + j + nx / 2];
			xr[j + nx / 2] = imr[i * nx + j];
			xi[j] = imi[i * nx + j + nx / 2];
			xi[j + nx / 2] = imi[i * nx + j];
		}

		// FFT̎s
		FFT(ir, nx, xr, xi, si, co, br);

		// f[^̓ւi_𒆉ɖ߂j
		for (j = 0; j < nx / 2; j++) {
			imr[i * nx + j + nx / 2] = (float)xr[j];
			imr[i * nx + j] = (float)xr[j + nx / 2];
			imi[i * nx + j + nx / 2] = (float)xi[j];
			imi[i * nx + j] = (float)xi[j + nx / 2];
		}
	}

	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);

	// y̔z̊m
	xr = (double*)malloc((size_t)ny * sizeof(double));
	xi = (double*)malloc((size_t)ny * sizeof(double));
	si = (double*)malloc((size_t)ny / 2 * sizeof(double));
	co = (double*)malloc((size_t)ny / 2 * sizeof(double));
	br = (unsigned int*)malloc((size_t)ny * sizeof(unsigned int));

	// FFTɕKvȃf[^̍쐬
	FFTInit(ny, si, co, br);

	// ỹt[Gϊ
	for (i = 0; i < nx; i++) {
		// f[^̓ւi_擪Ɉړj
		for (j = 0; j < ny / 2; j++) {
			xr[j] = imr[(j + ny / 2) * nx + i];
			xr[j + ny / 2] = imr[j * nx + i];
			xi[j] = imi[(j + ny / 2) * nx + i];
			xi[j + ny / 2] = imi[j * nx + i];
		}

		// FFT̎s
		FFT(ir, ny, xr, xi, si, co, br);

		// f[^̓ւi_𒆉ɖ߂j
		for (j = 0; j < ny / 2; j++) {
			imr[(j + ny / 2)* nx + i] = (float)xr[j];
			imr[j * nx + i] = (float)xr[j + nx / 2];
			imi[(j + ny / 2) * nx + i] = (float)xi[j];
			imi[j * nx + i] = (float)xi[j + nx / 2];
		}
	}

	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);
}
