#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define  PI  3.14159265358979

// vO̐
char *fname = "P5-08dose_ellipsoid.c";
char *title = "ȉ~̉摜쐬vO";

// ̓j[
char *menu[] = {
	" 1/10. o͉摜t@C  ",
	" 2/10. 摜̕@ (pixel)  ",
	" 3/10. 摜̍ (pixel)@",
	" 4/10. 摜̉s (pixel)@",
	" 5/10. ȉ~̒SxW   ",
	" 6/10. ȉ~̒SyW   ",
	" 7/10. ȉ~̒SzW   ",
	" 8/10. ȉ~̂̌aixj ",
	" 9/10. ȉ~̂̌aiyj ",
	"10/10. ȉ~̂̌aizj ",
};

// O[oϐ̐錾Əlݒ
char    g_f1[50] = "n5-08.imv";  // 1. o͉摜t@C
int     g_nx = 256;              // 2. 摜̕   (pixel)
int     g_ny = 256;              // 3. 摜̍ (pixel)
int     g_nz = 256;              // 4. 摜̉s (pixel)
double  g_x0 = 0.0;              // 5. ȉ~̒SxW
double  g_y0 = -30.0;            // 6. ȉ~̒SyW
double  g_z0 = 0.0;              // 7. ȉ~̒SzW
double  g_a = 30;                // 8. ȉ~̒aixj
double  g_b = 20;                // 9. ȉ~̒Zaiyj
double  g_c = 20;                //10. ȉ~̒Zaiyj

float* g_img;  // 摜̈

// vg^Cv錾
void dose_ellipsoid(float* img, int nx, int ny, int nz, double x0, double y0, double z0, double a, double b, double c);
void write_data(char*, float*, int);

// ^CgƓ̓j[̕\ƕϐւ̒l̓
void getparameter(void)
{
	int   i = 0;
	char  dat[256];

	// ^Cgƃt@C̕\
	printf("\n%s\n", title);
	printf("[ FileF%s ]\n\n", fname);

	// ϐւ̒l̓
	printf(" %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = 0; strcpy(g_f1, dat); }
	printf(" %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	printf(" %s [%d] :", menu[i++], g_nz);
	if (*fgets(dat, 256, stdin) != '\n')  g_nz = atoi(dat);
	printf(" %s [%f] :", menu[i++], g_x0);
	if (*fgets(dat, 256, stdin) != '\n')  g_x0 = atof(dat);
	printf(" %s [%f] :", menu[i++], g_y0);
	if (*fgets(dat, 256, stdin) != '\n')  g_y0 = atof(dat);
	printf(" %s [%f] :", menu[i++], g_z0);
	if (*fgets(dat, 256, stdin) != '\n')  g_z0 = atof(dat);
	printf(" %s [%f] :", menu[i++], g_a);
	if (*fgets(dat, 256, stdin) != '\n')  g_a = atof(dat);
	printf(" %s [%f] :", menu[i++], g_b);
	if (*fgets(dat, 256, stdin) != '\n')  g_b = atof(dat);
	printf(" %s [%f] :", menu[i++], g_c);
	if (*fgets(dat, 256, stdin) != '\n')  g_c = atof(dat);

	printf("\n");
}

int main(void)
{
	int   i;

	getparameter();

	// 摜̈̊m
	g_img = (float*)malloc((size_t)g_nx * g_ny * g_nz * sizeof(float));

	// 摜̈̏
	for (i = 0; i < g_nx * g_ny * g_nz; i++)
		g_img[i] = 0;

	// ȉ~̏Ǝˋx摜̍쐬
	dose_ellipsoid(g_img, g_nx, g_ny, g_nz, g_x0, g_y0, g_z0, g_a, g_b, g_c);

	// 摜̏o
	write_data(g_f1, g_img, g_nx * g_ny * g_nz);

	// 摜̈̊J
	free(g_img);

	return 0;
}

// ȉ~̉摜̍쐬
// float  *img; // 摜̈
// int     nx;  // 摜̕
// int     ny;  // 摜̍
// int     nz;  // 摜̉s
// double  x0;  // ȉ~̒SxW
// double  y0;  // ȉ~̒SyW
// double  z0;  // ȉ~̒SzW
// double  a;   // ȉ~̂̌aixj
// double  b;   // ȉ~̂̌aiyj
// double  c;   // ȉ~̂̌aizj
void dose_ellipsoid(float* img, int nx, int ny, int nz, double x0, double y0, double z0, double a, double b, double c)
{
	int  i, j, k, ii, jj, kk;
	int  n = 4;  // A`GCAVO

	for (i = 0; i < nz; i++) {
		double z = nz / 2 - i - z0;
		for (j = 0; j < ny; j++) {
			double y = ny / 2 - j - y0;
			for (k = 0; k < nx; k++) {
				double x = k - nx / 2 - x0;
				for (ii = 0; ii < n; ii++) {
					double zz = z + (2 * ii - n + 1) / (double)(2 * n);
					for (jj = 0; jj < n; jj++) {
						double yy = y + (2 * jj - n + 1) / (double)(2 * n);
						for (kk = 0; kk < n; kk++) {
							double xx = x + (2 * kk - n + 1) / (double)(2 * n);
							double d = (xx * xx) / (a * a) + (yy * yy) / (b * b) + (zz * zz) / (c * c);
							if (d <= 1)
								img[i * nx * ny + j * nx + k] += 1;
						}
					}
				}
				img[i * nx * ny + j * nx + k] /= (n * n * n);
			}
		}
	}
}

// *** 摜f[^̏óifloat^Ƃďój***
// char*  fi;   // o͉摜̃t@C
// float* img;  // o͉摜f[^
// int  size;   // o͉摜̃TCY
void write_data(char* fi, float* img, int size)
{
	FILE* fp;

	if ((fp = fopen(fi, "wb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	fwrite(img, sizeof(float), size, fp);
	fclose(fp);
}
